// Postprocessed
/* ------------------------------------------------------------
copyright: "Copyright (c) 2023 Punk Labs LLC"
license: "GPLv3 (or later)"
name: "OneTrick URCHIN DSP"
Code generated with Faust 2.72.14 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Cymbal -dtl 65536 -es 1 -mcd 16 -mdd 1024 -mdy 33 -single -ftz 0
------------------------------------------------------------ */
use faust_types::*;




pub struct DSP_CymbalSIG0 {
	iVec9: [i32;2],
	iRec41: [i32;2],
}

impl DSP_CymbalSIG0 {
	
	fn get_num_inputsDSP_CymbalSIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_CymbalSIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_CymbalSIG0(&mut self, sample_rate: i32) {
		for l35 in 0..2 {
			self.iVec9[l35 as usize] = 0;
		}
		for l36 in 0..2 {
			self.iRec41[l36 as usize] = 0;
		}
	}
	
	fn fillDSP_CymbalSIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iVec9[0] = 1;
			self.iRec41[0] = (i32::wrapping_add(self.iVec9[1], self.iRec41[1])) % 65536;
			table[i1 as usize] = F32::sin(9.58738e-05 * (self.iRec41[0]) as F32);
			self.iVec9[1] = self.iVec9[0];
			self.iRec41[1] = self.iRec41[0];
		}
	}

}


pub fn newDSP_CymbalSIG0() -> DSP_CymbalSIG0 { 
	DSP_CymbalSIG0 {
		iVec9: [0;2],
		iRec41: [0;2],
	}
}
fn DSP_Cymbal_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
fn DSP_Cymbal_faustpower3_f(value: F32) -> F32 {
	return value * value * value;
}
static mut ftbl0DSP_CymbalSIG0: [F32;65536] = [0.0;65536];
mod ffi {
	use std::os::raw::{c_float};
	#[cfg_attr(not(target_os="windows"), link(name="m"))]
	extern {
		pub fn remainderf(from: c_float, to: c_float) -> c_float;
		pub fn rintf(val: c_float) -> c_float;
	}
}
fn remainder_f32(from: f32, to: f32) -> f32 {
	unsafe { ffi::remainderf(from, to) }
}
fn rint_f32(val: f32) -> f32 {
	unsafe { ffi::rintf(val) }
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Cymbal {
	iVec0: [i32;2],
	fEntry0: F32,
	IOTA0: i32,
	fVec1: [F32;4096],
	fSampleRate: i32,
	fConst0: F32,
	fConst1: F32,
	fHslider0: F32,
	fConst2: F32,
	fVec2: [F32;2],
	iVec3: [i32;2],
	fButton0: F32,
	fVec4: [F32;2],
	fConst3: F32,
	fEntry1: F32,
	fEntry2: F32,
	fHslider1: F32,
	fRec2: [F32;2],
	fHslider2: F32,
	fRec1: [F32;2],
	iVec5: [i32;2],
	iRec0: [i32;2],
	fConst4: F32,
	iRec3: [i32;2],
	fRec4: [F32;2],
	fConst5: F32,
	fHslider3: F32,
	fConst6: F32,
	fHslider4: F32,
	fHslider5: F32,
	fConst7: F32,
	fConst8: F32,
	fConst9: F32,
	iVec6: [i32;2],
	fConst10: F32,
	fRec8: [F32;2],
	iRec9: [i32;2],
	fConst11: F32,
	fConst12: F32,
	fHslider6: F32,
	fRec10: [F32;2],
	fVec7: [F32;2],
	fRec11: [F32;2],
	fHslider7: F32,
	fConst13: F32,
	iRec12: [i32;2],
	fConst14: F32,
	fConst15: F32,
	iConst16: i32,
	iRec18: [i32;2],
	iRec19: [i32;2],
	fRec17: [F32;2],
	fRec15: [F32;2],
	fRec16: [F32;2],
	fRec14: [F32;3],
	fRec13: [F32;3],
	fRec20: [F32;2],
	fHslider8: F32,
	fHslider9: F32,
	fConst17: F32,
	fConst18: F32,
	fConst19: F32,
	fConst20: F32,
	fConst21: F32,
	fConst22: F32,
	fConst23: F32,
	fConst24: F32,
	fConst25: F32,
	fConst26: F32,
	fConst27: F32,
	fHslider10: F32,
	fHslider11: F32,
	fConst28: F32,
	fRec32: [F32;2],
	fRec31: [F32;2],
	fConst29: F32,
	fRec30: [F32;2],
	fRec37: [F32;2],
	fRec36: [F32;2],
	fRec35: [F32;2],
	fConst30: F32,
	fRec38: [F32;3],
	fVec8: [F32;2],
	fRec34: [F32;2],
	fConst31: F32,
	fRec42: [F32;2],
	fConst32: F32,
	fRec43: [F32;2],
	fConst33: F32,
	iRec47: [i32;2],
	fRec46: [F32;2],
	fRec44: [F32;2],
	fRec45: [F32;2],
	fVec10: [F32;4096],
	fConst34: F32,
	fRec39: [F32;2],
	fRec40: [F32;2],
	fConst35: F32,
	fRec55: [F32;2],
	fRec53: [F32;2],
	fRec54: [F32;2],
	fVec11: [F32;2048],
	fRec51: [F32;2],
	fRec52: [F32;2],
	fConst36: F32,
	fRec60: [F32;2],
	fRec58: [F32;2],
	fRec59: [F32;2],
	fVec12: [F32;2048],
	fRec56: [F32;2],
	fRec57: [F32;2],
	fConst37: F32,
	fRec65: [F32;2],
	fRec63: [F32;2],
	fRec64: [F32;2],
	fVec13: [F32;2048],
	fRec61: [F32;2],
	fRec62: [F32;2],
	fHslider12: F32,
	fRec68: [F32;2],
	fRec67: [F32;2],
	fRec66: [F32;2],
	fConst38: F32,
	fConst39: F32,
	fRec69: [F32;3],
	fRec33: [F32;3],
	fRec29: [F32;3],
	fRec28: [F32;3],
	fRec27: [F32;3],
	fRec26: [F32;3],
	fRec25: [F32;3],
	fRec24: [F32;3],
	fRec23: [F32;3],
	fRec22: [F32;3],
	fRec21: [F32;3],
	fHslider13: F32,
	fEntry3: F32,
	fRec7: [F32;3],
	fRec6: [F32;3],
	fRec5: [F32;3],
	fHslider14: F32,
	fHslider15: F32,
}

impl FaustDsp for DSP_Cymbal {
	type T = F32;
		
	fn new() -> DSP_Cymbal { 
		DSP_Cymbal {
			iVec0: [0;2],
			fEntry0: 0.0,
			IOTA0: 0,
			fVec1: [0.0;4096],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst1: 0.0,
			fHslider0: 0.0,
			fConst2: 0.0,
			fVec2: [0.0;2],
			iVec3: [0;2],
			fButton0: 0.0,
			fVec4: [0.0;2],
			fConst3: 0.0,
			fEntry1: 0.0,
			fEntry2: 0.0,
			fHslider1: 0.0,
			fRec2: [0.0;2],
			fHslider2: 0.0,
			fRec1: [0.0;2],
			iVec5: [0;2],
			iRec0: [0;2],
			fConst4: 0.0,
			iRec3: [0;2],
			fRec4: [0.0;2],
			fConst5: 0.0,
			fHslider3: 0.0,
			fConst6: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
			fConst7: 0.0,
			fConst8: 0.0,
			fConst9: 0.0,
			iVec6: [0;2],
			fConst10: 0.0,
			fRec8: [0.0;2],
			iRec9: [0;2],
			fConst11: 0.0,
			fConst12: 0.0,
			fHslider6: 0.0,
			fRec10: [0.0;2],
			fVec7: [0.0;2],
			fRec11: [0.0;2],
			fHslider7: 0.0,
			fConst13: 0.0,
			iRec12: [0;2],
			fConst14: 0.0,
			fConst15: 0.0,
			iConst16: 0,
			iRec18: [0;2],
			iRec19: [0;2],
			fRec17: [0.0;2],
			fRec15: [0.0;2],
			fRec16: [0.0;2],
			fRec14: [0.0;3],
			fRec13: [0.0;3],
			fRec20: [0.0;2],
			fHslider8: 0.0,
			fHslider9: 0.0,
			fConst17: 0.0,
			fConst18: 0.0,
			fConst19: 0.0,
			fConst20: 0.0,
			fConst21: 0.0,
			fConst22: 0.0,
			fConst23: 0.0,
			fConst24: 0.0,
			fConst25: 0.0,
			fConst26: 0.0,
			fConst27: 0.0,
			fHslider10: 0.0,
			fHslider11: 0.0,
			fConst28: 0.0,
			fRec32: [0.0;2],
			fRec31: [0.0;2],
			fConst29: 0.0,
			fRec30: [0.0;2],
			fRec37: [0.0;2],
			fRec36: [0.0;2],
			fRec35: [0.0;2],
			fConst30: 0.0,
			fRec38: [0.0;3],
			fVec8: [0.0;2],
			fRec34: [0.0;2],
			fConst31: 0.0,
			fRec42: [0.0;2],
			fConst32: 0.0,
			fRec43: [0.0;2],
			fConst33: 0.0,
			iRec47: [0;2],
			fRec46: [0.0;2],
			fRec44: [0.0;2],
			fRec45: [0.0;2],
			fVec10: [0.0;4096],
			fConst34: 0.0,
			fRec39: [0.0;2],
			fRec40: [0.0;2],
			fConst35: 0.0,
			fRec55: [0.0;2],
			fRec53: [0.0;2],
			fRec54: [0.0;2],
			fVec11: [0.0;2048],
			fRec51: [0.0;2],
			fRec52: [0.0;2],
			fConst36: 0.0,
			fRec60: [0.0;2],
			fRec58: [0.0;2],
			fRec59: [0.0;2],
			fVec12: [0.0;2048],
			fRec56: [0.0;2],
			fRec57: [0.0;2],
			fConst37: 0.0,
			fRec65: [0.0;2],
			fRec63: [0.0;2],
			fRec64: [0.0;2],
			fVec13: [0.0;2048],
			fRec61: [0.0;2],
			fRec62: [0.0;2],
			fHslider12: 0.0,
			fRec68: [0.0;2],
			fRec67: [0.0;2],
			fRec66: [0.0;2],
			fConst38: 0.0,
			fConst39: 0.0,
			fRec69: [0.0;3],
			fRec33: [0.0;3],
			fRec29: [0.0;3],
			fRec28: [0.0;3],
			fRec27: [0.0;3],
			fRec26: [0.0;3],
			fRec25: [0.0;3],
			fRec24: [0.0;3],
			fRec23: [0.0;3],
			fRec22: [0.0;3],
			fRec21: [0.0;3],
			fHslider13: 0.0,
			fEntry3: 0.0,
			fRec7: [0.0;3],
			fRec6: [0.0;3],
			fRec5: [0.0;3],
			fHslider14: 0.0,
			fHslider15: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/downSample:author", r"Romain Michon");
		m.declare("basics.lib/name", r"Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", r"Romain Michon");
		m.declare("basics.lib/tabulateNd", r"Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", r"1.15.0");
		m.declare("compile_options", r"-a arch.rs -lang rust -ct 0 -cn DSP_Cymbal -dtl 65536 -es 1 -mcd 16 -mdd 1024 -mdy 33 -single -ftz 0");
		m.declare("copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("delays.lib/name", r"Faust Delay Library");
		m.declare("delays.lib/version", r"1.1.0");
		m.declare("envelopes.lib/adsr:author", r"Yann Orlarey and Andrey Bundin");
		m.declare("envelopes.lib/ar:author", r"Yann Orlarey, Stéphane Letz");
		m.declare("envelopes.lib/author", r"GRAME");
		m.declare("envelopes.lib/copyright", r"GRAME");
		m.declare("envelopes.lib/license", r"LGPL with exception");
		m.declare("envelopes.lib/name", r"Faust Envelope Library");
		m.declare("envelopes.lib/version", r"1.3.0");
		m.declare("filename", r"cymbal.dsp");
		m.declare("filters.lib/fb_fcomb:author", r"Julius O. Smith III");
		m.declare("filters.lib/fb_fcomb:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fb_fcomb:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/fir:author", r"Julius O. Smith III");
		m.declare("filters.lib/fir:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fir:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/highpass:author", r"Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:author", r"Julius O. Smith III");
		m.declare("filters.lib/iir:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/lowpass0_highpass1", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/lowpass0_highpass1:author", r"Julius O. Smith III");
		m.declare("filters.lib/lowpass:author", r"Julius O. Smith III");
		m.declare("filters.lib/lowpass:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/name", r"Faust Filters Library");
		m.declare("filters.lib/notchw:author", r"Julius O. Smith III");
		m.declare("filters.lib/notchw:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/notchw:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/peak_eq:author", r"Julius O. Smith III");
		m.declare("filters.lib/peak_eq:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/peak_eq:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf2:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2s:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf2s:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2s:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/version", r"1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", r"Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", r"MIT");
		m.declare("interpolators.lib/name", r"Faust Interpolator Library");
		m.declare("interpolators.lib/remap:author", r"David Braun");
		m.declare("interpolators.lib/version", r"1.3.1");
		m.declare("license", r"GPLv3 (or later)");
		m.declare("maths.lib/author", r"GRAME");
		m.declare("maths.lib/copyright", r"GRAME");
		m.declare("maths.lib/license", r"LGPL with exception");
		m.declare("maths.lib/name", r"Faust Math Library");
		m.declare("maths.lib/version", r"2.8.0");
		m.declare("misceffects.lib/dryWetMixer:author", r"David Braun, revised by Stéphane Letz");
		m.declare("misceffects.lib/name", r"Misc Effects Library");
		m.declare("misceffects.lib/version", r"2.4.0");
		m.declare("name", r"OneTrick URCHIN DSP");
		m.declare("noises.lib/name", r"Faust Noise Generator Library");
		m.declare("noises.lib/version", r"1.4.1");
		m.declare("onetrick.lib/copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("onetrick.lib/license", r"GPLv3 (or later)");
		m.declare("onetrick.lib/name", r"OneTrick DSP Library");
		m.declare("oscillators.lib/name", r"Faust Oscillator Library");
		m.declare("oscillators.lib/version", r"1.5.1");
		m.declare("platform.lib/name", r"Generic Platform Library");
		m.declare("platform.lib/version", r"1.3.0");
		m.declare("shared.lib/copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("shared.lib/license", r"GPLv3 (or later)");
		m.declare("shared.lib/name", r"OneTrick URCHIN DSP");
		m.declare("signals.lib/name", r"Faust Signal Routing Library");
		m.declare("signals.lib/version", r"1.5.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_CymbalSIG0 = newDSP_CymbalSIG0();
		sig0.instance_initDSP_CymbalSIG0(sample_rate);
		sig0.fillDSP_CymbalSIG0(65536, unsafe { &mut ftbl0DSP_CymbalSIG0 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fButton0 = 0.0;
		self.fEntry1 = 0.0;
		self.fEntry2 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 2e+01;
		self.fHslider4 = 0.0;
		self.fHslider5 = 1.5;
		self.fHslider6 = 0.0;
		self.fHslider7 = 75.0;
		self.fHslider8 = 14.0;
		self.fHslider9 = 1e+02;
		self.fHslider10 = 0.0;
		self.fHslider11 = 0.0;
		self.fHslider12 = 5e+01;
		self.fHslider13 = 0.0;
		self.fEntry3 = 0.0;
		self.fHslider14 = 0.0;
		self.fHslider15 = 5e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[l0 as usize] = 0;
		}
		self.IOTA0 = 0;
		for l1 in 0..4096 {
			self.fVec1[l1 as usize] = 0.0;
		}
		for l2 in 0..2 {
			self.fVec2[l2 as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec3[l3 as usize] = 0;
		}
		for l4 in 0..2 {
			self.fVec4[l4 as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[l5 as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec1[l6 as usize] = 0.0;
		}
		for l7 in 0..2 {
			self.iVec5[l7 as usize] = 0;
		}
		for l8 in 0..2 {
			self.iRec0[l8 as usize] = 0;
		}
		for l9 in 0..2 {
			self.iRec3[l9 as usize] = 0;
		}
		for l10 in 0..2 {
			self.fRec4[l10 as usize] = 0.0;
		}
		for l11 in 0..2 {
			self.iVec6[l11 as usize] = 0;
		}
		for l12 in 0..2 {
			self.fRec8[l12 as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.iRec9[l13 as usize] = 0;
		}
		for l14 in 0..2 {
			self.fRec10[l14 as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fVec7[l15 as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec11[l16 as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.iRec12[l17 as usize] = 0;
		}
		for l18 in 0..2 {
			self.iRec18[l18 as usize] = 0;
		}
		for l19 in 0..2 {
			self.iRec19[l19 as usize] = 0;
		}
		for l20 in 0..2 {
			self.fRec17[l20 as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec15[l21 as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec16[l22 as usize] = 0.0;
		}
		for l23 in 0..3 {
			self.fRec14[l23 as usize] = 0.0;
		}
		for l24 in 0..3 {
			self.fRec13[l24 as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec20[l25 as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec32[l26 as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec31[l27 as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec30[l28 as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec37[l29 as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec36[l30 as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec35[l31 as usize] = 0.0;
		}
		for l32 in 0..3 {
			self.fRec38[l32 as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fVec8[l33 as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec34[l34 as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec42[l37 as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec43[l38 as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.iRec47[l39 as usize] = 0;
		}
		for l40 in 0..2 {
			self.fRec46[l40 as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec44[l41 as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec45[l42 as usize] = 0.0;
		}
		for l43 in 0..4096 {
			self.fVec10[l43 as usize] = 0.0;
		}
		for l44 in 0..2 {
			self.fRec39[l44 as usize] = 0.0;
		}
		for l45 in 0..2 {
			self.fRec40[l45 as usize] = 0.0;
		}
		for l46 in 0..2 {
			self.fRec55[l46 as usize] = 0.0;
		}
		for l47 in 0..2 {
			self.fRec53[l47 as usize] = 0.0;
		}
		for l48 in 0..2 {
			self.fRec54[l48 as usize] = 0.0;
		}
		for l49 in 0..2048 {
			self.fVec11[l49 as usize] = 0.0;
		}
		for l50 in 0..2 {
			self.fRec51[l50 as usize] = 0.0;
		}
		for l51 in 0..2 {
			self.fRec52[l51 as usize] = 0.0;
		}
		for l52 in 0..2 {
			self.fRec60[l52 as usize] = 0.0;
		}
		for l53 in 0..2 {
			self.fRec58[l53 as usize] = 0.0;
		}
		for l54 in 0..2 {
			self.fRec59[l54 as usize] = 0.0;
		}
		for l55 in 0..2048 {
			self.fVec12[l55 as usize] = 0.0;
		}
		for l56 in 0..2 {
			self.fRec56[l56 as usize] = 0.0;
		}
		for l57 in 0..2 {
			self.fRec57[l57 as usize] = 0.0;
		}
		for l58 in 0..2 {
			self.fRec65[l58 as usize] = 0.0;
		}
		for l59 in 0..2 {
			self.fRec63[l59 as usize] = 0.0;
		}
		for l60 in 0..2 {
			self.fRec64[l60 as usize] = 0.0;
		}
		for l61 in 0..2048 {
			self.fVec13[l61 as usize] = 0.0;
		}
		for l62 in 0..2 {
			self.fRec61[l62 as usize] = 0.0;
		}
		for l63 in 0..2 {
			self.fRec62[l63 as usize] = 0.0;
		}
		for l64 in 0..2 {
			self.fRec68[l64 as usize] = 0.0;
		}
		for l65 in 0..2 {
			self.fRec67[l65 as usize] = 0.0;
		}
		for l66 in 0..2 {
			self.fRec66[l66 as usize] = 0.0;
		}
		for l67 in 0..3 {
			self.fRec69[l67 as usize] = 0.0;
		}
		for l68 in 0..3 {
			self.fRec33[l68 as usize] = 0.0;
		}
		for l69 in 0..3 {
			self.fRec29[l69 as usize] = 0.0;
		}
		for l70 in 0..3 {
			self.fRec28[l70 as usize] = 0.0;
		}
		for l71 in 0..3 {
			self.fRec27[l71 as usize] = 0.0;
		}
		for l72 in 0..3 {
			self.fRec26[l72 as usize] = 0.0;
		}
		for l73 in 0..3 {
			self.fRec25[l73 as usize] = 0.0;
		}
		for l74 in 0..3 {
			self.fRec24[l74 as usize] = 0.0;
		}
		for l75 in 0..3 {
			self.fRec23[l75 as usize] = 0.0;
		}
		for l76 in 0..3 {
			self.fRec22[l76 as usize] = 0.0;
		}
		for l77 in 0..3 {
			self.fRec21[l77 as usize] = 0.0;
		}
		for l78 in 0..3 {
			self.fRec7[l78 as usize] = 0.0;
		}
		for l79 in 0..3 {
			self.fRec6[l79 as usize] = 0.0;
		}
		for l80 in 0..3 {
			self.fRec5[l80 as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, (self.fSampleRate) as F32));
		self.fConst1 = 0.02 * self.fConst0;
		self.fConst2 = 0.001 * self.fConst0;
		self.fConst3 = F32::exp(-(1e+02 / self.fConst0));
		self.fConst4 = 1.0 / F32::max(1.0, self.fConst2);
		self.fConst5 = 0.475 * self.fConst0;
		self.fConst6 = 3.1415927 / self.fConst0;
		self.fConst7 = 6283.1855 / self.fConst0;
		self.fConst8 = 1570.7964 / self.fConst0;
		self.fConst9 = 3141.5928 / self.fConst0;
		self.fConst10 = 0.00015 * self.fConst0;
		self.fConst11 = F32::max(1.0, self.fConst10);
		self.fConst12 = 1.0 / self.fConst11;
		self.fConst13 = 0.003 * self.fConst0;
		self.fConst14 = 0.005 * self.fConst0;
		self.fConst15 = self.fConst0 / F32::min(F32::min(4.8e+04, self.fConst0), self.fConst0);
		self.iConst16 = (self.fConst15) as i32;
		self.fConst17 = 628.31854 / self.fConst0;
		self.fConst18 = 28902.652 / self.fConst0;
		self.fConst19 = 12566.371 / self.fConst0;
		self.fConst20 = 3134.1506 / self.fConst0;
		self.fConst21 = 4084.0706 / self.fConst0;
		self.fConst22 = 8168.141 / self.fConst0;
		self.fConst23 = 78.53982 / self.fConst0;
		self.fConst24 = 7728.318 / self.fConst0;
		self.fConst25 = 2607.522 / self.fConst0;
		self.fConst26 = 942.4778 / self.fConst0;
		self.fConst27 = F32::exp(-(1e+03 / self.fConst0));
		self.fConst28 = 1.0 / self.fConst0;
		self.fConst29 = 1.0 - self.fConst27;
		self.fConst30 = F32::log(0.0010795455 * self.fConst0, std::f32::consts::E);
		self.fConst31 = 9.31 / self.fConst0;
		self.fConst32 = 15.31 / self.fConst0;
		self.fConst33 = 0.011764706 * self.fConst0;
		self.fConst34 = self.fConst0 + 1.0;
		self.fConst35 = 0.0052731493 * self.fConst0;
		self.fConst36 = 0.0061207004 * self.fConst0;
		self.fConst37 = 0.008296002 * self.fConst0;
		self.fConst38 = 6.2831855 / self.fConst0;
		self.fConst39 = 5.5866294 / self.fConst0;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Cymbal::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("OneTrick URCHIN DSP");
		ui_interface.add_horizontal_slider("Closed", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_num_entry("GainAdjustment", ParamIndex(1), 0.0, -1e+02, 12.0, 0.1);
		ui_interface.add_num_entry("PitchWheel", ParamIndex(2), 0.0, -1.0, 1.0, 0.001);
		ui_interface.add_num_entry("Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.001);
		ui_interface.add_num_entry("Trigger", ParamIndex(4), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_button("WakeUp", ParamIndex(5));
		ui_interface.declare(Some(ParamIndex(6)), "010", "");
		ui_interface.declare(Some(ParamIndex(6)), "export", "Damp");
		ui_interface.declare(Some(ParamIndex(6)), "unit", "%");
		ui_interface.add_horizontal_slider("Damp", ParamIndex(6), 0.0, 0.0, 1e+02, 0.0001);
		ui_interface.declare(Some(ParamIndex(7)), "020", "");
		ui_interface.declare(Some(ParamIndex(7)), "export", "Size");
		ui_interface.declare(Some(ParamIndex(7)), "unit", "in");
		ui_interface.add_horizontal_slider("Cymbal_Size", ParamIndex(7), 14.0, 1e+01, 24.0, 0.01);
		ui_interface.declare(Some(ParamIndex(8)), "030", "");
		ui_interface.declare(Some(ParamIndex(8)), "export", "Crash");
		ui_interface.declare(Some(ParamIndex(8)), "unit", "%");
		ui_interface.add_horizontal_slider("Cymbal_Crash", ParamIndex(8), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(9)), "1010", "");
		ui_interface.declare(Some(ParamIndex(9)), "export", "Lateness");
		ui_interface.declare(Some(ParamIndex(9)), "unit", "ms");
		ui_interface.add_horizontal_slider("Lateness", ParamIndex(9), 0.0, 0.0, 2e+01, 0.01);
		ui_interface.declare(Some(ParamIndex(10)), "1020", "");
		ui_interface.declare(Some(ParamIndex(10)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(10)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(10), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(11)), "1030", "");
		ui_interface.declare(Some(ParamIndex(11)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(11)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(11), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(12)), "1050", "");
		ui_interface.declare(Some(ParamIndex(12)), "export", "Reverb Send");
		ui_interface.declare(Some(ParamIndex(12)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(12), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(13)), "1060", "");
		ui_interface.declare(Some(ParamIndex(13)), "export", "Voice Punchiness");
		ui_interface.declare(Some(ParamIndex(13)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Punchiness", ParamIndex(13), 0.0, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(14)), "1070", "");
		ui_interface.declare(Some(ParamIndex(14)), "export", "Cutoff");
		ui_interface.declare(Some(ParamIndex(14)), "unit", "kHz");
		ui_interface.add_horizontal_slider("Sample_Cutoff", ParamIndex(14), 2e+01, 2.0, 2e+01, 0.01);
		ui_interface.declare(Some(ParamIndex(15)), "1080", "");
		ui_interface.declare(Some(ParamIndex(15)), "export", "Sample ToneFreq");
		ui_interface.declare(Some(ParamIndex(15)), "unit", "kHz");
		ui_interface.add_horizontal_slider("Sample_ToneFreq", ParamIndex(15), 1.5, 1.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(16)), "1090", "");
		ui_interface.declare(Some(ParamIndex(16)), "export", "Sample ToneGain");
		ui_interface.declare(Some(ParamIndex(16)), "unit", "db");
		ui_interface.add_horizontal_slider("Sample_ToneGain", ParamIndex(16), 0.0, 0.0, 6.0, 0.01);
		ui_interface.declare(Some(ParamIndex(17)), "1160", "");
		ui_interface.declare(Some(ParamIndex(17)), "export", "Sample Length");
		ui_interface.declare(Some(ParamIndex(17)), "minlabel", "∞");
		ui_interface.declare(Some(ParamIndex(17)), "unit", "s");
		ui_interface.add_horizontal_slider("Sample_Length", ParamIndex(17), 0.0, 0.0, 3.0, 0.01);
		ui_interface.declare(Some(ParamIndex(18)), "1165", "");
		ui_interface.declare(Some(ParamIndex(18)), "export", "Sample Speed");
		ui_interface.declare(Some(ParamIndex(18)), "unit", "st");
		ui_interface.add_horizontal_slider("Sample_Speed", ParamIndex(18), 0.0, -12.0, 12.0, 0.001);
		ui_interface.declare(Some(ParamIndex(19)), "1170", "");
		ui_interface.declare(Some(ParamIndex(19)), "export", "Mix Strike");
		ui_interface.declare(Some(ParamIndex(19)), "unit", "%");
		ui_interface.add_horizontal_slider("Mix_Strike", ParamIndex(19), 1e+02, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(20)), "1180", "");
		ui_interface.declare(Some(ParamIndex(20)), "export", "Strike Brightness");
		ui_interface.declare(Some(ParamIndex(20)), "unit", "%");
		ui_interface.add_horizontal_slider("Strike_Brightness", ParamIndex(20), 75.0, 0.0, 1e+02, 0.001);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			5 => Some(self.fButton0),
			4 => Some(self.fEntry0),
			2 => Some(self.fEntry1),
			3 => Some(self.fEntry2),
			1 => Some(self.fEntry3),
			9 => Some(self.fHslider0),
			18 => Some(self.fHslider1),
			0 => Some(self.fHslider10),
			6 => Some(self.fHslider11),
			8 => Some(self.fHslider12),
			10 => Some(self.fHslider13),
			11 => Some(self.fHslider14),
			12 => Some(self.fHslider15),
			17 => Some(self.fHslider2),
			14 => Some(self.fHslider3),
			16 => Some(self.fHslider4),
			15 => Some(self.fHslider5),
			13 => Some(self.fHslider6),
			20 => Some(self.fHslider7),
			7 => Some(self.fHslider8),
			19 => Some(self.fHslider9),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			5 => { self.fButton0 = value }
			4 => { self.fEntry0 = value }
			2 => { self.fEntry1 = value }
			3 => { self.fEntry2 = value }
			1 => { self.fEntry3 = value }
			9 => { self.fHslider0 = value }
			18 => { self.fHslider1 = value }
			0 => { self.fHslider10 = value }
			6 => { self.fHslider11 = value }
			8 => { self.fHslider12 = value }
			10 => { self.fHslider13 = value }
			11 => { self.fHslider14 = value }
			12 => { self.fHslider15 = value }
			17 => { self.fHslider2 = value }
			14 => { self.fHslider3 = value }
			16 => { self.fHslider4 = value }
			15 => { self.fHslider5 = value }
			13 => { self.fHslider6 = value }
			20 => { self.fHslider7 = value }
			7 => { self.fHslider8 = value }
			19 => { self.fHslider9 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut iSlow1: i32 = (F32::min(self.fConst1, F32::max(0.0, self.fConst2 * self.fHslider0))) as i32;
		let mut fSlow2: F32 = self.fButton0;
		let mut fSlow3: F32 = self.fHslider1 + self.fEntry2 + 12.0 * self.fEntry1;
		let mut fSlow4: F32 = self.fHslider2;
		let mut fSlow5: F32 = self.fConst0 * fSlow4;
		let mut fSlow6: F32 = ((fSlow4 > 0.0) as i32) as u32 as F32;
		let mut fSlow7: F32 = 1e+03 * self.fHslider3;
		let mut fSlow8: F32 = self.fHslider4;
		let mut iSlow9: i32 = (fSlow8 > 0.0) as i32;
		let mut fSlow10: F32 = self.fHslider5;
		let mut fSlow11: F32 = F32::sin(self.fConst7 * fSlow10);
		let mut fSlow12: F32 = self.fConst8 * (fSlow10 * F32::powf(1e+01, 0.05 * F32::abs(fSlow8)) / fSlow11);
		let mut fSlow13: F32 = self.fConst8 * (fSlow10 / fSlow11);
		let mut fSlow14: F32 = if iSlow9 != 0 {fSlow13} else {fSlow12};
		let mut fSlow15: F32 = F32::tan(self.fConst9 * fSlow10);
		let mut fSlow16: F32 = 1.0 / fSlow15;
		let mut fSlow17: F32 = fSlow16 * (fSlow16 + fSlow14) + 1.0;
		let mut fSlow18: F32 = if iSlow9 != 0 {fSlow12} else {fSlow13};
		let mut fSlow19: F32 = fSlow16 * (fSlow16 - fSlow18) + 1.0;
		let mut fSlow20: F32 = 2.0 * (1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fSlow15));
		let mut fSlow21: F32 = fSlow16 * (fSlow16 - fSlow14) + 1.0;
		let mut fSlow22: F32 = 0.01 * self.fHslider6;
		let mut fSlow23: F32 = self.fHslider7;
		let mut fSlow24: F32 = 4.4e+02 * F32::powf(2.0, 0.083333336 * (0.5186314 * fSlow23 + 2.213095));
		let mut fSlow25: F32 = 4.4e+02 * F32::powf(2.0, 0.083333336 * (0.3101955 * fSlow23 + -41.51318));
		let mut fSlow26: F32 = self.fHslider8 + -1e+01;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * (3.0 - 0.42857143 * fSlow26));
		let mut fSlow28: F32 = self.fHslider9;
		let mut fSlow29: F32 = 0.015848933 * (fSlow28 * F32::powf(1e+01, 0.05 * (-12.0 - 0.09 * fSlow23)) / fSlow27);
		let mut fSlow30: F32 = 4.4e+02 * F32::powf(2.0, 0.083333336 * (0.5812045 * fSlow26 + 50.213097));
		let mut fSlow31: F32 = self.fHslider10;
		let mut fSlow32: F32 = (0.9 * (1.0 - 0.01 * self.fHslider11) + 0.1) * (3.5 * DSP_Cymbal_faustpower3_f(0.071428575 * fSlow26) + 0.5) * (1.0 - 0.95 * fSlow31);
		let mut fSlow33: F32 = 0.25 * fSlow32;
		let mut fSlow34: F32 = fSlow26 * (1.0 - fSlow31 + 1.0);
		let mut fSlow35: F32 = F32::log(F32::powf(2.0, 0.083333336 * (41.369507 - 0.9698719 * fSlow34)), std::f32::consts::E);
		let mut fSlow36: F32 = fSlow35 - F32::log(F32::powf(2.0, 0.083333336 * (41.369507 - 2.142857 * fSlow34)), std::f32::consts::E);
		let mut fSlow37: F32 = 0.25 * (0.0028571428 * fSlow26 + 0.2);
		let mut fSlow38: F32 = F32::log(F32::powf(2.0, 0.083333336 * (0.37049553 * fSlow23 + 26.213095)), std::f32::consts::E);
		let mut fSlow39: F32 = self.fConst30 - fSlow38;
		let mut fSlow40: F32 = 0.01 * fSlow28;
		let mut fSlow41: F32 = 0.3971641 / fSlow27;
		let mut fSlow42: F32 = 0.01 * self.fHslider12;
		let mut fSlow43: F32 = 0.3548134 * (1.0 - fSlow42);
		let mut fSlow44: F32 = 0.125 * fSlow32;
		let mut fSlow45: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fEntry3 + self.fHslider13 + 6.0));
		let mut fSlow46: F32 = 0.11220185 * fSlow27 * fSlow45;
		let mut fSlow47: F32 = fSlow16 * (fSlow16 + fSlow18) + 1.0;
		let mut fSlow48: F32 = 0.01 * self.fHslider14;
		let mut fSlow49: F32 = 0.5 * fSlow45 * F32::min(1.0, 1.0 - fSlow48);
		let mut fSlow50: F32 = 0.5 * fSlow45 * F32::min(1.0, fSlow48 + 1.0);
		let mut fSlow51: F32 = 0.005 * self.fHslider15 * fSlow45;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[(self.IOTA0 & 4095) as usize] = fSlow0;
			let mut fTemp0: F32 = self.fVec1[((i32::wrapping_sub(self.IOTA0, iSlow1)) & 4095) as usize];
			self.fVec2[0] = fTemp0;
			let mut iTemp1: i32 = (fTemp0 > self.fVec2[1]) as i32;
			self.iVec3[0] = iTemp1;
			self.fVec4[0] = fSlow2;
			let mut fTemp2: F32 = ((fSlow2 <= self.fVec4[1]) as i32) as u32 as F32;
			let mut fTemp3: F32 = 1.0 - self.fConst3 * fTemp2;
			self.fRec2[0] = fSlow3 * fTemp3 + self.fConst3 * fTemp2 * self.fRec2[1];
			let mut fTemp4: F32 = F32::powf(2.0, 0.083333336 * self.fRec2[0]);
			self.fRec1[0] = if (iTemp1 > 0) as i32 != 0 {fSlow5 / fTemp4} else {F32::max(0.0, self.fRec1[1] + -1.0)};
			let mut iTemp5: i32 = (self.fRec1[0] > 0.0) as i32;
			self.iVec5[0] = iTemp5;
			self.iRec0[0] = ((iTemp5 == 0) as i32) * (i32::wrapping_add(self.iRec0[1], 1));
			self.iRec3[0] = i32::wrapping_add(iTemp5, i32::wrapping_mul(self.iRec3[1], (self.iVec5[1] >= iTemp5) as i32));
			self.fRec4[0] = fSlow6 * fTemp3 + self.fConst3 * fTemp2 * self.fRec4[1];
			let mut fTemp6: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, fSlow7 * fTemp4));
			let mut fTemp7: F32 = 1.0 / fTemp6;
			let mut fTemp8: F32 = (fTemp7 + 0.76536685) / fTemp6 + 1.0;
			let mut fTemp9: F32 = 1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fTemp6);
			let mut fTemp10: F32 = (fTemp7 + 1.847759) / fTemp6 + 1.0;
			let mut fTemp11: F32 = fSlow20 * self.fRec7[1];
			let mut iTemp12: i32 = (iTemp1 > self.iVec3[1]) as i32;
			self.iVec6[0] = iTemp12;
			self.fRec8[0] = if (iTemp12 > 0) as i32 != 0 {self.fConst10} else {F32::max(0.0, self.fRec8[1] + -1.0)};
			self.iRec9[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec9[1], (self.iRec9[1] > 0) as i32), (iTemp12 <= self.iVec6[1]) as i32), (iTemp12 > self.iVec6[1]) as i32);
			let mut fTemp13: F32 = (self.iRec9[0]) as F32;
			self.fRec10[0] = fSlow22 * fTemp3 + self.fConst3 * fTemp2 * self.fRec10[1];
			let mut fTemp14: F32 = F32::max(0.0, F32::min(self.fConst12 * fTemp13, (self.fConst11 - fTemp13) / F32::max(1.0, self.fConst0 * ((0.5 - 0.35 * self.fRec10[0]) / fTemp4)) + 1.0));
			self.fVec7[0] = fTemp14;
			self.fRec11[0] = if iTemp12 != 0 {self.fVec7[1]} else {self.fRec11[1]};
			let mut fTemp15: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, fSlow24 * fTemp4));
			let mut fTemp16: F32 = 1.0 / fTemp15;
			let mut fTemp17: F32 = (fTemp16 + 1.4142135) / fTemp15 + 1.0;
			let mut fTemp18: F32 = F32::max(1.0, self.fConst13 / fTemp4);
			self.iRec12[0] = i32::wrapping_add(iTemp12, i32::wrapping_mul(i32::wrapping_add(self.iRec12[1], (self.iRec12[1] > 0) as i32), (iTemp1 <= self.iVec3[1]) as i32));
			let mut fTemp19: F32 = (self.iRec12[0]) as F32;
			let mut fTemp20: F32 = F32::tan(self.fConst6 * F32::max(4e+01, fSlow25 * fTemp4));
			let mut fTemp21: F32 = 1.0 / fTemp20;
			let mut fTemp22: F32 = (fTemp21 + 1.4142135) / fTemp20 + 1.0;
			let mut fTemp23: F32 = DSP_Cymbal_faustpower2_f(fTemp20);
			self.iRec18[0] = i32::wrapping_add(self.iRec18[1], 1);
			let mut iTemp24: i32 = (((i32::wrapping_add(self.iRec18[0], -1)) % self.iConst16) == 0) as i32;
			self.iRec19[0] = i32::wrapping_add(i32::wrapping_mul(1103515245, self.iRec19[1]), 12345);
			self.fRec17[0] = if iTemp24 != 0 {4.656613e-10 * (self.iRec19[0]) as F32} else {self.fRec17[1]};
			let mut fTemp25: F32 = if (self.fRec17[0] != self.fRec17[1]) as i32 != 0 {self.fConst15} else {self.fRec15[1] + -1.0};
			self.fRec15[0] = fTemp25;
			self.fRec16[0] = if (fTemp25 > 0.0) as i32 != 0 {self.fRec16[1] + (self.fRec17[0] - self.fRec16[1]) / fTemp25} else {self.fRec17[0]};
			self.fRec14[0] = self.fRec16[0] - (self.fRec14[2] * ((fTemp21 + -1.4142135) / fTemp20 + 1.0) + 2.0 * self.fRec14[1] * (1.0 - 1.0 / fTemp23)) / fTemp22;
			self.fRec13[0] = (self.fRec14[2] + (self.fRec14[0] - 2.0 * self.fRec14[1])) / (fTemp23 * fTemp22) - (self.fRec13[2] * ((fTemp16 + -1.4142135) / fTemp15 + 1.0) + 2.0 * self.fRec13[1] * (1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fTemp15))) / fTemp17;
			self.fRec20[0] = if iTemp1 != 0 {0.99 * fTemp0 + 0.01} else {self.fRec20[1]};
			let mut fTemp26: F32 = self.fConst17 * fTemp4;
			let mut fTemp27: F32 = DSP_Cymbal_faustpower2_f(fTemp26 + 1.0);
			let mut fTemp28: F32 = DSP_Cymbal_faustpower2_f(1.0 - fTemp26);
			let mut fTemp29: F32 = F32::cos(self.fConst18 * fTemp4);
			let mut fTemp30: F32 = fTemp28 / fTemp27 + 1.0;
			let mut fTemp31: F32 = F32::tan(self.fConst7 * fTemp4);
			let mut fTemp32: F32 = fTemp4 / F32::sin(self.fConst19 * fTemp4);
			let mut fTemp33: F32 = self.fConst20 * fTemp32;
			let mut fTemp34: F32 = 1.0 / fTemp31;
			let mut fTemp35: F32 = (fTemp34 + fTemp33) / fTemp31 + 1.0;
			let mut fTemp36: F32 = self.fConst8 * fTemp32;
			let mut fTemp37: F32 = DSP_Cymbal_faustpower2_f(fTemp31);
			let mut fTemp38: F32 = 1.0 - 1.0 / fTemp37;
			let mut fTemp39: F32 = 2.0 * fTemp38 * self.fRec22[1];
			let mut fTemp40: F32 = F32::tan(self.fConst21 * fTemp4);
			let mut fTemp41: F32 = fTemp4 / F32::sin(self.fConst22 * fTemp4);
			let mut fTemp42: F32 = self.fConst20 * fTemp41;
			let mut fTemp43: F32 = 1.0 / fTemp40;
			let mut fTemp44: F32 = (fTemp43 + fTemp42) / fTemp40 + 1.0;
			let mut fTemp45: F32 = self.fConst8 * fTemp41;
			let mut fTemp46: F32 = 2.0 * self.fRec23[1] * (1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fTemp40));
			let mut fTemp47: F32 = self.fConst23 * fTemp4;
			let mut fTemp48: F32 = DSP_Cymbal_faustpower2_f(fTemp47 + 1.0);
			let mut fTemp49: F32 = DSP_Cymbal_faustpower2_f(1.0 - fTemp47);
			let mut fTemp50: F32 = self.fRec24[1] * F32::cos(self.fConst24 * fTemp4);
			let mut fTemp51: F32 = F32::cos(self.fConst25 * fTemp4);
			let mut fTemp52: F32 = fTemp49 / fTemp48 + 1.0;
			let mut fTemp53: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, fSlow30 * fTemp4));
			let mut fTemp54: F32 = 1.0 / fTemp53;
			let mut fTemp55: F32 = (fTemp54 + 1.4142135) / fTemp53 + 1.0;
			let mut fTemp56: F32 = F32::tan(self.fConst8 * fTemp4);
			let mut fTemp57: F32 = 1.0 / fTemp56;
			let mut fTemp58: F32 = (fTemp57 + 1.4142135) / fTemp56 + 1.0;
			let mut fTemp59: F32 = DSP_Cymbal_faustpower2_f(fTemp56);
			let mut fTemp60: F32 = F32::tan(self.fConst26 * fTemp4);
			let mut fTemp61: F32 = 1.0 / fTemp60;
			let mut fTemp62: F32 = (fTemp61 + 0.76536685) / fTemp60 + 1.0;
			let mut fTemp63: F32 = DSP_Cymbal_faustpower2_f(fTemp60);
			let mut fTemp64: F32 = 1.0 - 1.0 / fTemp63;
			let mut fTemp65: F32 = (fTemp61 + 1.847759) / fTemp60 + 1.0;
			let mut fTemp66: F32 = (i32::wrapping_sub(1, iTemp12)) as F32;
			let mut fTemp67: F32 = fSlow33 * (fTemp66 * (1.7 * (DSP_Cymbal_faustpower3_f(1.0 - self.fRec31[1]) - 1.0) + 1.75) / fTemp4);
			let mut iTemp68: i32 = (F32::abs(fTemp67) < 1.1920929e-07) as i32;
			let mut fTemp69: F32 = if iTemp68 != 0 {0.0} else {F32::exp(-(self.fConst28 / if iTemp68 != 0 {1.0} else {fTemp67}))};
			let mut fTemp70: F32 = 0.5 * self.fRec20[0];
			let mut fTemp71: F32 = (iTemp12) as F32;
			self.fRec32[0] = fTemp71 * (1.0 - fTemp69) * F32::min(1.0, F32::max(fTemp70 + self.fRec31[1], self.fRec20[0])) + fTemp69 * self.fRec32[1];
			self.fRec31[0] = self.fRec32[0];
			self.fRec30[0] = self.fConst29 * self.fRec31[0] + self.fConst27 * self.fRec30[1];
			let mut fTemp72: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, F32::max(2e+01, 4.4e+02 * fTemp4 * F32::powf(2.0, 1.442695 * (fSlow35 - fSlow36 * self.fRec30[0])))));
			let mut fTemp73: F32 = 1.0 / fTemp72;
			let mut fTemp74: F32 = (fTemp73 + 1.4142135) / fTemp72 + 1.0;
			let mut fTemp75: F32 = DSP_Cymbal_faustpower2_f(fTemp72);
			let mut fTemp76: F32 = fSlow37 * fTemp66 * (1.7 * (DSP_Cymbal_faustpower3_f(1.0 - self.fRec36[1]) - 1.0) + 1.75);
			let mut iTemp77: i32 = (F32::abs(fTemp76) < 1.1920929e-07) as i32;
			let mut fTemp78: F32 = if iTemp77 != 0 {0.0} else {F32::exp(-(self.fConst28 / if iTemp77 != 0 {1.0} else {fTemp76}))};
			self.fRec37[0] = (1.0 - fTemp78) * F32::min(1.0, F32::max(self.fRec36[1] + fTemp70, self.fRec20[0])) * fTemp71 + fTemp78 * self.fRec37[1];
			self.fRec36[0] = self.fRec37[0];
			self.fRec35[0] = self.fConst29 * self.fRec36[0] + self.fConst27 * self.fRec35[1];
			let mut fTemp79: F32 = 1.0 / F32::tan(self.fConst6 * F32::min(self.fConst5, 4.4e+02 * fTemp4 * F32::powf(2.0, 1.442695 * (fSlow38 + fSlow39 * self.fRec35[0]))));
			let mut fTemp80: F32 = (fTemp34 + 1.4142135) / fTemp31 + 1.0;
			self.fRec38[0] = fSlow40 * self.fRec35[0] * self.fRec16[0] - (self.fRec38[2] * ((fTemp34 + -1.4142135) / fTemp31 + 1.0) + 2.0 * self.fRec38[1] * fTemp38) / fTemp80;
			let mut fTemp81: F32 = (self.fRec38[2] + (self.fRec38[0] - 2.0 * self.fRec38[1])) / (fTemp37 * fTemp80);
			self.fVec8[0] = fTemp81;
			self.fRec34[0] = -((self.fRec34[1] * (1.0 - fTemp79) - (fTemp81 + self.fVec8[1])) / (fTemp79 + 1.0));
			let mut fTemp82: F32 = fSlow32 / fTemp4;
			let mut iTemp83: i32 = (F32::abs(fTemp82) < 1.1920929e-07) as i32;
			let mut fTemp84: F32 = if iTemp83 != 0 {0.0} else {F32::exp(-(self.fConst28 / if iTemp83 != 0 {1.0} else {fTemp82}))};
			let mut iTemp85: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp86: F32 = if iTemp85 != 0 {0.0} else {self.fConst31 + self.fRec42[1]};
			self.fRec42[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if iTemp85 != 0 {0.0} else {self.fConst32 + self.fRec43[1]};
			self.fRec43[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = (0.006 * unsafe { ftbl0DSP_CymbalSIG0[((65536.0 * self.fRec43[0]) as i32) as usize] } + 1.0) * (0.006 * unsafe { ftbl0DSP_CymbalSIG0[((65536.0 * self.fRec42[0]) as i32) as usize] } + 1.0);
			let mut fTemp89: F32 = self.fConst33 / fTemp88;
			let mut iTemp90: i32 = i32::wrapping_mul(1103515245, i32::wrapping_add(self.iRec47[1], 12345));
			let mut iTemp91: i32 = i32::wrapping_mul(1103515245, i32::wrapping_add(iTemp90, 12345));
			let mut iTemp92: i32 = i32::wrapping_mul(1103515245, i32::wrapping_add(iTemp91, 12345));
			self.iRec47[0] = i32::wrapping_mul(1103515245, i32::wrapping_add(iTemp92, 12345));
			let mut iRec48: i32 = iTemp92;
			let mut iRec49: i32 = iTemp91;
			let mut iRec50: i32 = iTemp90;
			self.fRec46[0] = if iTemp24 != 0 {4.656613e-10 * (iRec50) as F32} else {self.fRec46[1]};
			let mut fTemp93: F32 = if (self.fRec46[0] != self.fRec46[1]) as i32 != 0 {self.fConst15} else {self.fRec44[1] + -1.0};
			self.fRec44[0] = fTemp93;
			self.fRec45[0] = if (fTemp93 > 0.0) as i32 != 0 {self.fRec45[1] + (self.fRec46[0] - self.fRec45[1]) / fTemp93} else {self.fRec46[0]};
			let mut fTemp94: F32 = self.fRec35[0] * self.fRec45[0];
			let mut fTemp95: F32 = F32::abs(fTemp94);
			let mut fTemp96: F32 = 1.0 / F32::min(F32::max(0.4 * self.fRec20[0] + 0.5, 0.001), 0.999) + -2.0;
			let mut fTemp97: F32 = 1.0 - 0.7 * self.fRec20[0];
			let mut fTemp98: F32 = fTemp97 * fTemp95 * (1.0 - (i32::wrapping_mul(2, (fTemp94 < 0.0) as i32)) as F32) / (fTemp96 * (1.0 - fTemp95) + 1.0) - 0.9999 * self.fRec39[1] * F32::powf(fTemp84, fTemp89);
			self.fVec10[(self.IOTA0 & 4095) as usize] = fTemp98;
			let mut fTemp99: F32 = (fTemp89) as i32 as F32;
			let mut fTemp100: F32 = fTemp99 + -0.95;
			let mut iTemp101: i32 = (fTemp100) as i32;
			let mut fTemp102: F32 = F32::floor(fTemp100);
			self.fRec39[0] = self.fVec10[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, iTemp101)) as F32)) as i32)) & 4095) as usize] * (fTemp102 + (1.95 - fTemp99)) + (fTemp99 + (-0.95 - fTemp102)) * self.fVec10[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, i32::wrapping_add(iTemp101, 1))) as F32)) as i32)) & 4095) as usize];
			self.fRec40[0] = fTemp98;
			let mut fTemp103: F32 = self.fConst35 / fTemp88;
			self.fRec55[0] = if iTemp24 != 0 {4.656613e-10 * (iRec49) as F32} else {self.fRec55[1]};
			let mut fTemp104: F32 = if (self.fRec55[0] != self.fRec55[1]) as i32 != 0 {self.fConst15} else {self.fRec53[1] + -1.0};
			self.fRec53[0] = fTemp104;
			self.fRec54[0] = if (fTemp104 > 0.0) as i32 != 0 {self.fRec54[1] + (self.fRec55[0] - self.fRec54[1]) / fTemp104} else {self.fRec55[0]};
			let mut fTemp105: F32 = self.fRec35[0] * self.fRec54[0];
			let mut fTemp106: F32 = F32::abs(fTemp105);
			let mut fTemp107: F32 = fTemp97 * fTemp106 * (1.0 - (i32::wrapping_mul(2, (fTemp105 < 0.0) as i32)) as F32) / (fTemp96 * (1.0 - fTemp106) + 1.0) - 0.9999 * self.fRec51[1] * F32::powf(fTemp84, fTemp103);
			self.fVec11[(self.IOTA0 & 2047) as usize] = fTemp107;
			let mut fTemp108: F32 = (fTemp103) as i32 as F32;
			let mut fTemp109: F32 = fTemp108 + -0.95;
			let mut iTemp110: i32 = (fTemp109) as i32;
			let mut fTemp111: F32 = F32::floor(fTemp109);
			self.fRec51[0] = self.fVec11[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, iTemp110)) as F32)) as i32)) & 2047) as usize] * (fTemp111 + (1.95 - fTemp108)) + (fTemp108 + (-0.95 - fTemp111)) * self.fVec11[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, i32::wrapping_add(iTemp110, 1))) as F32)) as i32)) & 2047) as usize];
			self.fRec52[0] = fTemp107;
			let mut fTemp112: F32 = self.fConst36 / fTemp88;
			self.fRec60[0] = if iTemp24 != 0 {4.656613e-10 * (iRec48) as F32} else {self.fRec60[1]};
			let mut fTemp113: F32 = if (self.fRec60[0] != self.fRec60[1]) as i32 != 0 {self.fConst15} else {self.fRec58[1] + -1.0};
			self.fRec58[0] = fTemp113;
			self.fRec59[0] = if (fTemp113 > 0.0) as i32 != 0 {self.fRec59[1] + (self.fRec60[0] - self.fRec59[1]) / fTemp113} else {self.fRec60[0]};
			let mut fTemp114: F32 = self.fRec35[0] * self.fRec59[0];
			let mut fTemp115: F32 = F32::abs(fTemp114);
			let mut fTemp116: F32 = fTemp97 * fTemp115 * (1.0 - (i32::wrapping_mul(2, (fTemp114 < 0.0) as i32)) as F32) / (fTemp96 * (1.0 - fTemp115) + 1.0) - 0.9999 * self.fRec56[1] * F32::powf(fTemp84, fTemp112);
			self.fVec12[(self.IOTA0 & 2047) as usize] = fTemp116;
			let mut fTemp117: F32 = (fTemp112) as i32 as F32;
			let mut fTemp118: F32 = fTemp117 + -0.95;
			let mut iTemp119: i32 = (fTemp118) as i32;
			let mut fTemp120: F32 = F32::floor(fTemp118);
			self.fRec56[0] = self.fVec12[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, iTemp119)) as F32)) as i32)) & 2047) as usize] * (fTemp120 + (1.95 - fTemp117)) + (fTemp117 + (-0.95 - fTemp120)) * self.fVec12[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, i32::wrapping_add(iTemp119, 1))) as F32)) as i32)) & 2047) as usize];
			self.fRec57[0] = fTemp116;
			let mut fTemp121: F32 = self.fConst37 / fTemp88;
			self.fRec65[0] = if iTemp24 != 0 {4.656613e-10 * (self.iRec47[0]) as F32} else {self.fRec65[1]};
			let mut fTemp122: F32 = if (self.fRec65[0] != self.fRec65[1]) as i32 != 0 {self.fConst15} else {self.fRec63[1] + -1.0};
			self.fRec63[0] = fTemp122;
			self.fRec64[0] = if (fTemp122 > 0.0) as i32 != 0 {self.fRec64[1] + (self.fRec65[0] - self.fRec64[1]) / fTemp122} else {self.fRec65[0]};
			let mut fTemp123: F32 = self.fRec64[0] * self.fRec35[0];
			let mut fTemp124: F32 = F32::abs(fTemp123);
			let mut fTemp125: F32 = fTemp124 * (1.0 - (i32::wrapping_mul(2, (fTemp123 < 0.0) as i32)) as F32) * fTemp97 / ((1.0 - fTemp124) * fTemp96 + 1.0) - 0.9999 * self.fRec61[1] * F32::powf(fTemp84, fTemp121);
			self.fVec13[(self.IOTA0 & 2047) as usize] = fTemp125;
			let mut fTemp126: F32 = (fTemp121) as i32 as F32;
			let mut fTemp127: F32 = fTemp126 + -0.95;
			let mut iTemp128: i32 = (fTemp127) as i32;
			let mut fTemp129: F32 = F32::floor(fTemp127);
			self.fRec61[0] = self.fVec13[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, iTemp128)) as F32)) as i32)) & 2047) as usize] * (fTemp129 + (1.95 - fTemp126)) + (fTemp126 + (-0.95 - fTemp129)) * self.fVec13[((i32::wrapping_sub(self.IOTA0, (F32::min(self.fConst34, (std::cmp::max(0, i32::wrapping_add(iTemp128, 1))) as F32)) as i32)) & 2047) as usize];
			self.fRec62[0] = fTemp125;
			let mut fTemp130: F32 = 0.1998 * (self.fRec62[1] + self.fRec57[1]) + 0.15984 * self.fRec52[1] + 0.11988 * self.fRec40[1];
			let mut fTemp131: F32 = fSlow44 * (fTemp66 * (1.7 * (DSP_Cymbal_faustpower3_f(1.0 - self.fRec67[1]) - 1.0) + 1.75) / fTemp4);
			let mut iTemp132: i32 = (F32::abs(fTemp131) < 1.1920929e-07) as i32;
			let mut fTemp133: F32 = if iTemp132 != 0 {0.0} else {F32::exp(-(self.fConst28 / if iTemp132 != 0 {1.0} else {fTemp131}))};
			self.fRec68[0] = fTemp71 * (1.0 - fTemp133) * F32::min(1.0, F32::max(fTemp70 + self.fRec67[1], self.fRec20[0])) + fTemp133 * self.fRec68[1];
			self.fRec67[0] = self.fRec68[0];
			self.fRec66[0] = self.fConst29 * self.fRec67[0] + self.fConst27 * self.fRec66[1];
			let mut fTemp134: F32 = fTemp4 * F32::powf(2.0, 0.083333336 * (63.26265 - 64.91269 * self.fRec66[0]));
			let mut fTemp135: F32 = F32::min(self.fConst5, F32::max(2e+01, 2.2e+02 * fTemp134));
			let mut fTemp136: F32 = F32::tan(self.fConst6 * fTemp135);
			let mut fTemp137: F32 = F32::min(self.fConst5, F32::max(2e+01, 6.6e+02 * fTemp134)) / F32::sin(self.fConst38 * fTemp135);
			let mut fTemp138: F32 = self.fConst6 * fTemp137;
			let mut fTemp139: F32 = 1.0 / fTemp136;
			let mut fTemp140: F32 = (fTemp139 + fTemp138) / fTemp136 + 1.0;
			let mut fTemp141: F32 = self.fConst39 * fTemp137;
			let mut fTemp142: F32 = 2.0 * self.fRec69[1] * (1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fTemp136));
			self.fRec69[0] = 0.3548134 * fTemp130 - (self.fRec69[2] * ((fTemp139 - fTemp138) / fTemp136 + 1.0) + fTemp142) / fTemp140;
			self.fRec33[0] = fSlow42 * ((fTemp142 + self.fRec69[0] * ((fTemp139 + fTemp141) / fTemp136 + 1.0) + self.fRec69[2] * ((fTemp139 - fTemp141) / fTemp136 + 1.0)) / fTemp140) + fSlow43 * fTemp130 + fSlow41 * self.fRec34[0] - (self.fRec33[2] * ((fTemp73 + -1.4142135) / fTemp72 + 1.0) + 2.0 * self.fRec33[1] * (1.0 - 1.0 / fTemp75)) / fTemp74;
			self.fRec29[0] = (self.fRec33[2] + (self.fRec33[0] - 2.0 * self.fRec33[1])) / (fTemp75 * fTemp74) - (self.fRec29[2] * ((fTemp61 + -1.847759) / fTemp60 + 1.0) + 2.0 * self.fRec29[1] * fTemp64) / fTemp65;
			self.fRec28[0] = (self.fRec29[2] + (self.fRec29[0] - 2.0 * self.fRec29[1])) / (fTemp63 * fTemp65) - (self.fRec28[2] * ((fTemp61 + -0.76536685) / fTemp60 + 1.0) + 2.0 * fTemp64 * self.fRec28[1]) / fTemp62;
			self.fRec27[0] = (self.fRec28[2] + (self.fRec28[0] - 2.0 * self.fRec28[1])) / (fTemp63 * fTemp62) - (self.fRec27[2] * ((fTemp57 + -1.4142135) / fTemp56 + 1.0) + 2.0 * self.fRec27[1] * (1.0 - 1.0 / fTemp59)) / fTemp58;
			self.fRec26[0] = (self.fRec27[2] + (self.fRec27[0] - 2.0 * self.fRec27[1])) / (fTemp59 * fTemp58) - (self.fRec26[2] * ((fTemp54 + -1.4142135) / fTemp53 + 1.0) + 2.0 * self.fRec26[1] * (1.0 - 1.0 / DSP_Cymbal_faustpower2_f(fTemp53))) / fTemp55;
			self.fRec25[0] = (self.fRec26[2] + self.fRec26[0] + 2.0 * self.fRec26[1]) / fTemp55 + self.fRec25[1] * fTemp52 * fTemp51 - fTemp49 * self.fRec25[2] / fTemp48;
			self.fRec24[0] = fTemp52 * (0.5 * self.fRec25[0] - self.fRec25[1] * fTemp51 + 0.5 * self.fRec25[2] + fTemp50) - fTemp49 * self.fRec24[2] / fTemp48;
			self.fRec23[0] = fTemp52 * (0.5 * self.fRec24[0] - fTemp50 + 0.5 * self.fRec24[2]) - (self.fRec23[2] * ((fTemp43 - fTemp42) / fTemp40 + 1.0) + fTemp46) / fTemp44;
			self.fRec22[0] = (fTemp46 + self.fRec23[0] * ((fTemp43 + fTemp45) / fTemp40 + 1.0) + self.fRec23[2] * ((fTemp43 - fTemp45) / fTemp40 + 1.0)) / fTemp44 - (self.fRec22[2] * ((fTemp34 - fTemp33) / fTemp31 + 1.0) + fTemp39) / fTemp35;
			self.fRec21[0] = (fTemp39 + self.fRec22[0] * ((fTemp34 + fTemp36) / fTemp31 + 1.0) + self.fRec22[2] * ((fTemp34 - fTemp36) / fTemp31 + 1.0)) / fTemp35 + self.fRec21[1] * fTemp30 * fTemp29 - fTemp28 * self.fRec21[2] / fTemp27;
			self.fRec7[0] = fSlow46 * (fTemp30 * (0.5 * self.fRec21[0] - self.fRec21[1] * fTemp29 + 0.5 * self.fRec21[2]) + fSlow29 * (self.fRec20[0] * (self.fRec13[2] + self.fRec13[0] + 2.0 * self.fRec13[1]) * F32::max(0.0, F32::min(fTemp19 / fTemp18, (fTemp18 - fTemp19) / F32::max(1.0, self.fConst14 / fTemp4) + 1.0)) / fTemp17)) * (1.0 - self.fRec10[0] + self.fRec10[0] * if (self.fRec8[0] > 0.0) as i32 != 0 {self.fRec11[0] + (1.0 - self.fRec11[0]) * fTemp14} else {fTemp14}) - (self.fRec7[2] * fSlow21 + fTemp11) / fSlow17;
			self.fRec6[0] = (fTemp11 + self.fRec7[0] * fSlow47 + self.fRec7[2] * fSlow19) / fSlow17 - (self.fRec6[2] * ((fTemp7 + -1.847759) / fTemp6 + 1.0) + 2.0 * self.fRec6[1] * fTemp9) / fTemp10;
			self.fRec5[0] = (self.fRec6[2] + self.fRec6[0] + 2.0 * self.fRec6[1]) / fTemp10 - (self.fRec5[2] * ((fTemp7 + -0.76536685) / fTemp6 + 1.0) + 2.0 * fTemp9 * self.fRec5[1]) / fTemp8;
			let mut fTemp143: F32 = (self.fRec5[2] + self.fRec5[0] + 2.0 * self.fRec5[1]) / fTemp8;
			let mut fTemp144: F32 = (fTemp143 + F32::tanh(fTemp143)) * (self.fRec4[0] * (F32::max(0.0, F32::min((self.iRec3[0]) as F32, 1.0) * (1.0 - self.fConst4 * (self.iRec0[0]) as F32)) + -1.0) + 1.0);
			*output0 = fSlow49 * fTemp144;
			*output1 = fSlow50 * fTemp144;
			*output2 = fSlow51 * fTemp144;
			self.iVec0[1] = self.iVec0[0];
			self.IOTA0 = i32::wrapping_add(self.IOTA0, 1);
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec1[1] = self.fRec1[0];
			self.iVec5[1] = self.iVec5[0];
			self.iRec0[1] = self.iRec0[0];
			self.iRec3[1] = self.iRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.iVec6[1] = self.iVec6[0];
			self.fRec8[1] = self.fRec8[0];
			self.iRec9[1] = self.iRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fVec7[1] = self.fVec7[0];
			self.fRec11[1] = self.fRec11[0];
			self.iRec12[1] = self.iRec12[0];
			self.iRec18[1] = self.iRec18[0];
			self.iRec19[1] = self.iRec19[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec14[2] = self.fRec14[1];
			self.fRec14[1] = self.fRec14[0];
			self.fRec13[2] = self.fRec13[1];
			self.fRec13[1] = self.fRec13[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec38[2] = self.fRec38[1];
			self.fRec38[1] = self.fRec38[0];
			self.fVec8[1] = self.fVec8[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec42[1] = self.fRec42[0];
			self.fRec43[1] = self.fRec43[0];
			self.iRec47[1] = self.iRec47[0];
			self.fRec46[1] = self.fRec46[0];
			self.fRec44[1] = self.fRec44[0];
			self.fRec45[1] = self.fRec45[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec55[1] = self.fRec55[0];
			self.fRec53[1] = self.fRec53[0];
			self.fRec54[1] = self.fRec54[0];
			self.fRec51[1] = self.fRec51[0];
			self.fRec52[1] = self.fRec52[0];
			self.fRec60[1] = self.fRec60[0];
			self.fRec58[1] = self.fRec58[0];
			self.fRec59[1] = self.fRec59[0];
			self.fRec56[1] = self.fRec56[0];
			self.fRec57[1] = self.fRec57[0];
			self.fRec65[1] = self.fRec65[0];
			self.fRec63[1] = self.fRec63[0];
			self.fRec64[1] = self.fRec64[0];
			self.fRec61[1] = self.fRec61[0];
			self.fRec62[1] = self.fRec62[0];
			self.fRec68[1] = self.fRec68[0];
			self.fRec67[1] = self.fRec67[0];
			self.fRec66[1] = self.fRec66[0];
			self.fRec69[2] = self.fRec69[1];
			self.fRec69[1] = self.fRec69[0];
			self.fRec33[2] = self.fRec33[1];
			self.fRec33[1] = self.fRec33[0];
			self.fRec29[2] = self.fRec29[1];
			self.fRec29[1] = self.fRec29[0];
			self.fRec28[2] = self.fRec28[1];
			self.fRec28[1] = self.fRec28[0];
			self.fRec27[2] = self.fRec27[1];
			self.fRec27[1] = self.fRec27[0];
			self.fRec26[2] = self.fRec26[1];
			self.fRec26[1] = self.fRec26[0];
			self.fRec25[2] = self.fRec25[1];
			self.fRec25[1] = self.fRec25[0];
			self.fRec24[2] = self.fRec24[1];
			self.fRec24[1] = self.fRec24[0];
			self.fRec23[2] = self.fRec23[1];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[2] = self.fRec22[1];
			self.fRec22[1] = self.fRec22[0];
			self.fRec21[2] = self.fRec21[1];
			self.fRec21[1] = self.fRec21[0];
			self.fRec7[2] = self.fRec7[1];
			self.fRec7[1] = self.fRec7[0];
			self.fRec6[2] = self.fRec6[1];
			self.fRec6[1] = self.fRec6[0];
			self.fRec5[2] = self.fRec5[1];
			self.fRec5[1] = self.fRec5[0];
		}
	}

}

