// Postprocessed
/* ------------------------------------------------------------
copyright: "Copyright (c) 2023 Punk Labs LLC"
license: "GPLv3 (or later)"
name: "OneTrick URCHIN DSP"
Code generated with Faust 2.72.14 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Snare -dtl 65536 -es 1 -mcd 16 -mdd 1024 -mdy 33 -single -ftz 0
------------------------------------------------------------ */
use faust_types::*;




pub struct DSP_SnareSIG0 {
	iVec9: [i32;2],
	iRec20: [i32;2],
}

impl DSP_SnareSIG0 {
	
	fn get_num_inputsDSP_SnareSIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG0(&mut self, sample_rate: i32) {
		for l22 in 0..2 {
			self.iVec9[l22 as usize] = 0;
		}
		for l23 in 0..2 {
			self.iRec20[l23 as usize] = 0;
		}
	}
	
	fn fillDSP_SnareSIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iVec9[0] = 1;
			self.iRec20[0] = (i32::wrapping_add(self.iVec9[1], self.iRec20[1])) % 65536;
			table[i1 as usize] = F32::sin(9.58738e-05 * (self.iRec20[0]) as F32);
			self.iVec9[1] = self.iVec9[0];
			self.iRec20[1] = self.iRec20[0];
		}
	}

}


pub fn newDSP_SnareSIG0() -> DSP_SnareSIG0 { 
	DSP_SnareSIG0 {
		iVec9: [0;2],
		iRec20: [0;2],
	}
}
fn DSP_Snare_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl0DSP_SnareSIG0: [F32;65536] = [0.0;65536];
fn DSP_Snare_faustpower3_f(value: F32) -> F32 {
	return value * value * value;
}
fn DSP_Snare_faustpower4_f(value: F32) -> F32 {
	return value * value * value * value;
}
mod ffi {
	use std::os::raw::{c_float};
	#[cfg_attr(not(target_os="windows"), link(name="m"))]
	extern {
		pub fn remainderf(from: c_float, to: c_float) -> c_float;
		pub fn rintf(val: c_float) -> c_float;
	}
}
fn remainder_f32(from: f32, to: f32) -> f32 {
	unsafe { ffi::remainderf(from, to) }
}
fn rint_f32(val: f32) -> f32 {
	unsafe { ffi::rintf(val) }
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Snare {
	iVec0: [i32;2],
	fEntry0: F32,
	IOTA0: i32,
	fVec1: [F32;4096],
	fSampleRate: i32,
	fConst0: F32,
	fConst1: F32,
	fHslider0: F32,
	fConst2: F32,
	fVec2: [F32;2],
	iVec3: [i32;2],
	fButton0: F32,
	fVec4: [F32;2],
	fConst3: F32,
	fEntry1: F32,
	fEntry2: F32,
	fHslider1: F32,
	fRec2: [F32;2],
	fHslider2: F32,
	fRec1: [F32;2],
	iVec5: [i32;2],
	iRec0: [i32;2],
	fConst4: F32,
	iRec3: [i32;2],
	fRec4: [F32;2],
	fConst5: F32,
	fHslider3: F32,
	fConst6: F32,
	fHslider4: F32,
	fHslider5: F32,
	fConst7: F32,
	fConst8: F32,
	fConst9: F32,
	iVec6: [i32;2],
	fConst10: F32,
	fRec8: [F32;2],
	iRec9: [i32;2],
	fConst11: F32,
	fConst12: F32,
	fHslider6: F32,
	fRec10: [F32;2],
	fVec7: [F32;2],
	fRec11: [F32;2],
	fConst13: F32,
	fConst14: F32,
	iRec14: [i32;2],
	fHslider7: F32,
	fRec18: [F32;2],
	fRec19: [F32;2],
	fVec8: [F32;1024],
	fConst15: F32,
	fHslider8: F32,
	fConst16: F32,
	fRec16: [F32;2],
	fConst17: F32,
	fRec22: [F32;2],
	fConst18: F32,
	fRec21: [F32;2],
	fConst19: F32,
	fHslider9: F32,
	fConst20: F32,
	fRec26: [F32;2],
	fRec25: [F32;2],
	fRec24: [F32;2],
	fConst21: F32,
	fRec23: [F32;2],
	fHslider10: F32,
	fHslider11: F32,
	fRec29: [F32;2],
	fRec28: [F32;2],
	fRec27: [F32;2],
	fHslider12: F32,
	fHslider13: F32,
	fHslider14: F32,
	fRec30: [F32;2],
	fRec33: [F32;2],
	fRec32: [F32;2],
	fRec31: [F32;2],
	fRec34: [F32;2],
	fRec37: [F32;2],
	fRec36: [F32;2],
	fRec35: [F32;2],
	fRec38: [F32;2],
	fRec41: [F32;2],
	fRec40: [F32;2],
	fRec39: [F32;2],
	fRec42: [F32;2],
	fRec45: [F32;2],
	fRec44: [F32;2],
	fRec43: [F32;2],
	fRec46: [F32;2],
	fRec49: [F32;2],
	fRec48: [F32;2],
	fRec47: [F32;2],
	fHslider15: F32,
	fConst22: F32,
	fConst23: F32,
	fConst24: F32,
	fConst25: F32,
	iRec52: [i32;2],
	fVec10: [F32;2],
	fConst26: F32,
	iRec59: [i32;2],
	fRec57: [F32;2],
	fConst27: F32,
	fRec56: [F32;2],
	fConst28: F32,
	fRec55: [F32;2],
	fVec11: [F32;2],
	fRec54: [F32;2],
	fConst29: F32,
	fConst30: F32,
	fRec53: [F32;2],
	fRec60: [F32;2],
	fRec51: [F32;3],
	fVec12: [F32;2],
	fRec50: [F32;2],
	fHslider16: F32,
	fHslider17: F32,
	fRec63: [F32;2],
	fRec62: [F32;2],
	fRec61: [F32;2],
	fRec64: [F32;2],
	fRec67: [F32;2],
	fRec66: [F32;2],
	fRec65: [F32;2],
	fRec68: [F32;2],
	fRec71: [F32;2],
	fRec70: [F32;2],
	fRec69: [F32;2],
	fRec72: [F32;2],
	fRec75: [F32;2],
	fRec74: [F32;2],
	fRec73: [F32;2],
	fRec76: [F32;2],
	fRec79: [F32;2],
	fRec78: [F32;2],
	fRec77: [F32;2],
	fRec80: [F32;2],
	fRec83: [F32;2],
	fRec82: [F32;2],
	fRec81: [F32;2],
	fRec86: [F32;2],
	fRec85: [F32;2],
	fRec84: [F32;2],
	fConst31: F32,
	iConst32: i32,
	iRec92: [i32;2],
	fRec91: [F32;2],
	fRec89: [F32;2],
	fRec90: [F32;2],
	fHslider18: F32,
	fRec88: [F32;3],
	fRec87: [F32;3],
	fConst33: F32,
	fConst34: F32,
	fConst35: F32,
	fConst36: F32,
	fConst37: F32,
	fConst38: F32,
	fConst39: F32,
	fConst40: F32,
	fConst41: F32,
	fConst42: F32,
	fConst43: F32,
	fConst44: F32,
	fConst45: F32,
	fConst46: F32,
	fRec94: [F32;2],
	fRec93: [F32;5],
	fConst47: F32,
	fConst48: F32,
	fRec95: [F32;5],
	fConst49: F32,
	fConst50: F32,
	iRec96: [i32;2],
	fConst51: F32,
	fRec98: [F32;3],
	fRec97: [F32;3],
	fHslider19: F32,
	fVec13: [F32;2],
	fRec99: [F32;2],
	fVec14: [F32;1024],
	fRec17: [F32;2],
	fRec15: [F32;2],
	fConst52: F32,
	fRec13: [F32;2],
	fConst53: F32,
	fConst54: F32,
	fConst55: F32,
	fRec12: [F32;2],
	fRec7: [F32;3],
	fRec6: [F32;3],
	fRec5: [F32;3],
	fHslider20: F32,
	fHslider21: F32,
	fEntry3: F32,
	fHslider22: F32,
}

impl FaustDsp for DSP_Snare {
	type T = F32;
		
	fn new() -> DSP_Snare { 
		DSP_Snare {
			iVec0: [0;2],
			fEntry0: 0.0,
			IOTA0: 0,
			fVec1: [0.0;4096],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst1: 0.0,
			fHslider0: 0.0,
			fConst2: 0.0,
			fVec2: [0.0;2],
			iVec3: [0;2],
			fButton0: 0.0,
			fVec4: [0.0;2],
			fConst3: 0.0,
			fEntry1: 0.0,
			fEntry2: 0.0,
			fHslider1: 0.0,
			fRec2: [0.0;2],
			fHslider2: 0.0,
			fRec1: [0.0;2],
			iVec5: [0;2],
			iRec0: [0;2],
			fConst4: 0.0,
			iRec3: [0;2],
			fRec4: [0.0;2],
			fConst5: 0.0,
			fHslider3: 0.0,
			fConst6: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
			fConst7: 0.0,
			fConst8: 0.0,
			fConst9: 0.0,
			iVec6: [0;2],
			fConst10: 0.0,
			fRec8: [0.0;2],
			iRec9: [0;2],
			fConst11: 0.0,
			fConst12: 0.0,
			fHslider6: 0.0,
			fRec10: [0.0;2],
			fVec7: [0.0;2],
			fRec11: [0.0;2],
			fConst13: 0.0,
			fConst14: 0.0,
			iRec14: [0;2],
			fHslider7: 0.0,
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fVec8: [0.0;1024],
			fConst15: 0.0,
			fHslider8: 0.0,
			fConst16: 0.0,
			fRec16: [0.0;2],
			fConst17: 0.0,
			fRec22: [0.0;2],
			fConst18: 0.0,
			fRec21: [0.0;2],
			fConst19: 0.0,
			fHslider9: 0.0,
			fConst20: 0.0,
			fRec26: [0.0;2],
			fRec25: [0.0;2],
			fRec24: [0.0;2],
			fConst21: 0.0,
			fRec23: [0.0;2],
			fHslider10: 0.0,
			fHslider11: 0.0,
			fRec29: [0.0;2],
			fRec28: [0.0;2],
			fRec27: [0.0;2],
			fHslider12: 0.0,
			fHslider13: 0.0,
			fHslider14: 0.0,
			fRec30: [0.0;2],
			fRec33: [0.0;2],
			fRec32: [0.0;2],
			fRec31: [0.0;2],
			fRec34: [0.0;2],
			fRec37: [0.0;2],
			fRec36: [0.0;2],
			fRec35: [0.0;2],
			fRec38: [0.0;2],
			fRec41: [0.0;2],
			fRec40: [0.0;2],
			fRec39: [0.0;2],
			fRec42: [0.0;2],
			fRec45: [0.0;2],
			fRec44: [0.0;2],
			fRec43: [0.0;2],
			fRec46: [0.0;2],
			fRec49: [0.0;2],
			fRec48: [0.0;2],
			fRec47: [0.0;2],
			fHslider15: 0.0,
			fConst22: 0.0,
			fConst23: 0.0,
			fConst24: 0.0,
			fConst25: 0.0,
			iRec52: [0;2],
			fVec10: [0.0;2],
			fConst26: 0.0,
			iRec59: [0;2],
			fRec57: [0.0;2],
			fConst27: 0.0,
			fRec56: [0.0;2],
			fConst28: 0.0,
			fRec55: [0.0;2],
			fVec11: [0.0;2],
			fRec54: [0.0;2],
			fConst29: 0.0,
			fConst30: 0.0,
			fRec53: [0.0;2],
			fRec60: [0.0;2],
			fRec51: [0.0;3],
			fVec12: [0.0;2],
			fRec50: [0.0;2],
			fHslider16: 0.0,
			fHslider17: 0.0,
			fRec63: [0.0;2],
			fRec62: [0.0;2],
			fRec61: [0.0;2],
			fRec64: [0.0;2],
			fRec67: [0.0;2],
			fRec66: [0.0;2],
			fRec65: [0.0;2],
			fRec68: [0.0;2],
			fRec71: [0.0;2],
			fRec70: [0.0;2],
			fRec69: [0.0;2],
			fRec72: [0.0;2],
			fRec75: [0.0;2],
			fRec74: [0.0;2],
			fRec73: [0.0;2],
			fRec76: [0.0;2],
			fRec79: [0.0;2],
			fRec78: [0.0;2],
			fRec77: [0.0;2],
			fRec80: [0.0;2],
			fRec83: [0.0;2],
			fRec82: [0.0;2],
			fRec81: [0.0;2],
			fRec86: [0.0;2],
			fRec85: [0.0;2],
			fRec84: [0.0;2],
			fConst31: 0.0,
			iConst32: 0,
			iRec92: [0;2],
			fRec91: [0.0;2],
			fRec89: [0.0;2],
			fRec90: [0.0;2],
			fHslider18: 0.0,
			fRec88: [0.0;3],
			fRec87: [0.0;3],
			fConst33: 0.0,
			fConst34: 0.0,
			fConst35: 0.0,
			fConst36: 0.0,
			fConst37: 0.0,
			fConst38: 0.0,
			fConst39: 0.0,
			fConst40: 0.0,
			fConst41: 0.0,
			fConst42: 0.0,
			fConst43: 0.0,
			fConst44: 0.0,
			fConst45: 0.0,
			fConst46: 0.0,
			fRec94: [0.0;2],
			fRec93: [0.0;5],
			fConst47: 0.0,
			fConst48: 0.0,
			fRec95: [0.0;5],
			fConst49: 0.0,
			fConst50: 0.0,
			iRec96: [0;2],
			fConst51: 0.0,
			fRec98: [0.0;3],
			fRec97: [0.0;3],
			fHslider19: 0.0,
			fVec13: [0.0;2],
			fRec99: [0.0;2],
			fVec14: [0.0;1024],
			fRec17: [0.0;2],
			fRec15: [0.0;2],
			fConst52: 0.0,
			fRec13: [0.0;2],
			fConst53: 0.0,
			fConst54: 0.0,
			fConst55: 0.0,
			fRec12: [0.0;2],
			fRec7: [0.0;3],
			fRec6: [0.0;3],
			fRec5: [0.0;3],
			fHslider20: 0.0,
			fHslider21: 0.0,
			fEntry3: 0.0,
			fHslider22: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("analyzers.lib/amp_follower_ar:author", r"Jonatan Liljedahl, revised by Romain Michon");
		m.declare("analyzers.lib/name", r"Faust Analyzer Library");
		m.declare("analyzers.lib/version", r"1.2.0");
		m.declare("basics.lib/downSample:author", r"Romain Michon");
		m.declare("basics.lib/name", r"Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", r"Romain Michon");
		m.declare("basics.lib/tabulateNd", r"Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", r"1.15.0");
		m.declare("compile_options", r"-a arch.rs -lang rust -ct 0 -cn DSP_Snare -dtl 65536 -es 1 -mcd 16 -mdd 1024 -mdy 33 -single -ftz 0");
		m.declare("copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("delays.lib/fdelay4:author", r"Julius O. Smith III");
		m.declare("delays.lib/fdelayltv:author", r"Julius O. Smith III");
		m.declare("delays.lib/name", r"Faust Delay Library");
		m.declare("delays.lib/version", r"1.1.0");
		m.declare("drum.lib/copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("drum.lib/license", r"GPLv3 (or later)");
		m.declare("drum.lib/name", r"OneTrick URCHIN DSP");
		m.declare("envelopes.lib/adsr:author", r"Yann Orlarey and Andrey Bundin");
		m.declare("envelopes.lib/ar:author", r"Yann Orlarey, Stéphane Letz");
		m.declare("envelopes.lib/are:author", r"Julius O. Smith III, revised by Stephane Letz");
		m.declare("envelopes.lib/are:licence", r"STK-4.3");
		m.declare("envelopes.lib/author", r"GRAME");
		m.declare("envelopes.lib/copyright", r"GRAME");
		m.declare("envelopes.lib/license", r"LGPL with exception");
		m.declare("envelopes.lib/name", r"Faust Envelope Library");
		m.declare("envelopes.lib/version", r"1.3.0");
		m.declare("filename", r"snare.dsp");
		m.declare("filters.lib/bandpass0_bandstop1:author", r"Julius O. Smith III");
		m.declare("filters.lib/bandpass0_bandstop1:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/bandpass0_bandstop1:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/bandpass:author", r"Julius O. Smith III");
		m.declare("filters.lib/bandpass:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/bandpass:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/dcblockerat:author", r"Julius O. Smith III");
		m.declare("filters.lib/dcblockerat:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/dcblockerat:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/fir:author", r"Julius O. Smith III");
		m.declare("filters.lib/fir:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fir:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/highpass:author", r"Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:author", r"Julius O. Smith III");
		m.declare("filters.lib/iir:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/lowpass0_highpass1", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/lowpass0_highpass1:author", r"Julius O. Smith III");
		m.declare("filters.lib/lowpass:author", r"Julius O. Smith III");
		m.declare("filters.lib/lowpass:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/name", r"Faust Filters Library");
		m.declare("filters.lib/peak_eq:author", r"Julius O. Smith III");
		m.declare("filters.lib/peak_eq:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/peak_eq:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/pole:author", r"Julius O. Smith III");
		m.declare("filters.lib/pole:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/pole:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf2:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2s:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf2s:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2s:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2sb:author", r"Julius O. Smith III");
		m.declare("filters.lib/tf2sb:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2sb:license", r"MIT-style STK-4.3 license");
		m.declare("filters.lib/version", r"1.3.0");
		m.declare("filters.lib/zero:author", r"Julius O. Smith III");
		m.declare("filters.lib/zero:copyright", r"Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/zero:license", r"MIT-style STK-4.3 license");
		m.declare("interpolators.lib/interpolate_linear:author", r"Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", r"MIT");
		m.declare("interpolators.lib/name", r"Faust Interpolator Library");
		m.declare("interpolators.lib/remap:author", r"David Braun");
		m.declare("interpolators.lib/version", r"1.3.1");
		m.declare("license", r"GPLv3 (or later)");
		m.declare("maths.lib/author", r"GRAME");
		m.declare("maths.lib/copyright", r"GRAME");
		m.declare("maths.lib/license", r"LGPL with exception");
		m.declare("maths.lib/name", r"Faust Math Library");
		m.declare("maths.lib/version", r"2.8.0");
		m.declare("misceffects.lib/dryWetMixer:author", r"David Braun, revised by Stéphane Letz");
		m.declare("misceffects.lib/gate_gain_mono:author", r"Julius O. Smith III");
		m.declare("misceffects.lib/gate_gain_mono:license", r"STK-4.3");
		m.declare("misceffects.lib/gate_mono:author", r"Julius O. Smith III");
		m.declare("misceffects.lib/gate_mono:license", r"STK-4.3");
		m.declare("misceffects.lib/name", r"Misc Effects Library");
		m.declare("misceffects.lib/version", r"2.4.0");
		m.declare("name", r"OneTrick URCHIN DSP");
		m.declare("noises.lib/name", r"Faust Noise Generator Library");
		m.declare("noises.lib/version", r"1.4.1");
		m.declare("onetrick.lib/copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("onetrick.lib/license", r"GPLv3 (or later)");
		m.declare("onetrick.lib/name", r"OneTrick DSP Library");
		m.declare("oscillators.lib/lf_sawpos:author", r"Bart Brouns, revised by Stéphane Letz");
		m.declare("oscillators.lib/lf_sawpos:licence", r"STK-4.3");
		m.declare("oscillators.lib/name", r"Faust Oscillator Library");
		m.declare("oscillators.lib/version", r"1.5.1");
		m.declare("physmodels.lib/name", r"Faust Physical Models Library");
		m.declare("physmodels.lib/version", r"1.1.0");
		m.declare("platform.lib/name", r"Generic Platform Library");
		m.declare("platform.lib/version", r"1.3.0");
		m.declare("routes.lib/name", r"Faust Signal Routing Library");
		m.declare("routes.lib/version", r"1.2.0");
		m.declare("shared.lib/copyright", r"Copyright (c) 2023 Punk Labs LLC");
		m.declare("shared.lib/license", r"GPLv3 (or later)");
		m.declare("shared.lib/name", r"OneTrick URCHIN DSP");
		m.declare("signals.lib/name", r"Faust Signal Routing Library");
		m.declare("signals.lib/onePoleSwitching:author", r"Jonatan Liljedahl, revised by Dario Sanfilippo");
		m.declare("signals.lib/onePoleSwitching:licence", r"STK-4.3");
		m.declare("signals.lib/version", r"1.5.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_SnareSIG0 = newDSP_SnareSIG0();
		sig0.instance_initDSP_SnareSIG0(sample_rate);
		sig0.fillDSP_SnareSIG0(65536, unsafe { &mut ftbl0DSP_SnareSIG0 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fButton0 = 0.0;
		self.fEntry1 = 0.0;
		self.fEntry2 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 2e+01;
		self.fHslider4 = 0.0;
		self.fHslider5 = 1.5;
		self.fHslider6 = 0.0;
		self.fHslider7 = 3e+01;
		self.fHslider8 = 12.0;
		self.fHslider9 = 0.5;
		self.fHslider10 = 0.0;
		self.fHslider11 = 35.0;
		self.fHslider12 = 8.0;
		self.fHslider13 = 0.0;
		self.fHslider14 = 1.2e+02;
		self.fHslider15 = 1e+02;
		self.fHslider16 = 1.0;
		self.fHslider17 = 5e+01;
		self.fHslider18 = 75.0;
		self.fHslider19 = 1e+02;
		self.fHslider20 = 0.0;
		self.fHslider21 = 0.0;
		self.fEntry3 = 0.0;
		self.fHslider22 = 5e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[l0 as usize] = 0;
		}
		self.IOTA0 = 0;
		for l1 in 0..4096 {
			self.fVec1[l1 as usize] = 0.0;
		}
		for l2 in 0..2 {
			self.fVec2[l2 as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec3[l3 as usize] = 0;
		}
		for l4 in 0..2 {
			self.fVec4[l4 as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[l5 as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec1[l6 as usize] = 0.0;
		}
		for l7 in 0..2 {
			self.iVec5[l7 as usize] = 0;
		}
		for l8 in 0..2 {
			self.iRec0[l8 as usize] = 0;
		}
		for l9 in 0..2 {
			self.iRec3[l9 as usize] = 0;
		}
		for l10 in 0..2 {
			self.fRec4[l10 as usize] = 0.0;
		}
		for l11 in 0..2 {
			self.iVec6[l11 as usize] = 0;
		}
		for l12 in 0..2 {
			self.fRec8[l12 as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.iRec9[l13 as usize] = 0;
		}
		for l14 in 0..2 {
			self.fRec10[l14 as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fVec7[l15 as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec11[l16 as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.iRec14[l17 as usize] = 0;
		}
		for l18 in 0..2 {
			self.fRec18[l18 as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec19[l19 as usize] = 0.0;
		}
		for l20 in 0..1024 {
			self.fVec8[l20 as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec16[l21 as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec22[l24 as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec21[l25 as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec26[l26 as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec25[l27 as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec24[l28 as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec23[l29 as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec29[l30 as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec28[l31 as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec27[l32 as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec30[l33 as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec33[l34 as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec32[l35 as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec31[l36 as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec34[l37 as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec37[l38 as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec36[l39 as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec35[l40 as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec38[l41 as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec41[l42 as usize] = 0.0;
		}
		for l43 in 0..2 {
			self.fRec40[l43 as usize] = 0.0;
		}
		for l44 in 0..2 {
			self.fRec39[l44 as usize] = 0.0;
		}
		for l45 in 0..2 {
			self.fRec42[l45 as usize] = 0.0;
		}
		for l46 in 0..2 {
			self.fRec45[l46 as usize] = 0.0;
		}
		for l47 in 0..2 {
			self.fRec44[l47 as usize] = 0.0;
		}
		for l48 in 0..2 {
			self.fRec43[l48 as usize] = 0.0;
		}
		for l49 in 0..2 {
			self.fRec46[l49 as usize] = 0.0;
		}
		for l50 in 0..2 {
			self.fRec49[l50 as usize] = 0.0;
		}
		for l51 in 0..2 {
			self.fRec48[l51 as usize] = 0.0;
		}
		for l52 in 0..2 {
			self.fRec47[l52 as usize] = 0.0;
		}
		for l53 in 0..2 {
			self.iRec52[l53 as usize] = 0;
		}
		for l54 in 0..2 {
			self.fVec10[l54 as usize] = 0.0;
		}
		for l55 in 0..2 {
			self.iRec59[l55 as usize] = 0;
		}
		for l56 in 0..2 {
			self.fRec57[l56 as usize] = 0.0;
		}
		for l57 in 0..2 {
			self.fRec56[l57 as usize] = 0.0;
		}
		for l58 in 0..2 {
			self.fRec55[l58 as usize] = 0.0;
		}
		for l59 in 0..2 {
			self.fVec11[l59 as usize] = 0.0;
		}
		for l60 in 0..2 {
			self.fRec54[l60 as usize] = 0.0;
		}
		for l61 in 0..2 {
			self.fRec53[l61 as usize] = 0.0;
		}
		for l62 in 0..2 {
			self.fRec60[l62 as usize] = 0.0;
		}
		for l63 in 0..3 {
			self.fRec51[l63 as usize] = 0.0;
		}
		for l64 in 0..2 {
			self.fVec12[l64 as usize] = 0.0;
		}
		for l65 in 0..2 {
			self.fRec50[l65 as usize] = 0.0;
		}
		for l66 in 0..2 {
			self.fRec63[l66 as usize] = 0.0;
		}
		for l67 in 0..2 {
			self.fRec62[l67 as usize] = 0.0;
		}
		for l68 in 0..2 {
			self.fRec61[l68 as usize] = 0.0;
		}
		for l69 in 0..2 {
			self.fRec64[l69 as usize] = 0.0;
		}
		for l70 in 0..2 {
			self.fRec67[l70 as usize] = 0.0;
		}
		for l71 in 0..2 {
			self.fRec66[l71 as usize] = 0.0;
		}
		for l72 in 0..2 {
			self.fRec65[l72 as usize] = 0.0;
		}
		for l73 in 0..2 {
			self.fRec68[l73 as usize] = 0.0;
		}
		for l74 in 0..2 {
			self.fRec71[l74 as usize] = 0.0;
		}
		for l75 in 0..2 {
			self.fRec70[l75 as usize] = 0.0;
		}
		for l76 in 0..2 {
			self.fRec69[l76 as usize] = 0.0;
		}
		for l77 in 0..2 {
			self.fRec72[l77 as usize] = 0.0;
		}
		for l78 in 0..2 {
			self.fRec75[l78 as usize] = 0.0;
		}
		for l79 in 0..2 {
			self.fRec74[l79 as usize] = 0.0;
		}
		for l80 in 0..2 {
			self.fRec73[l80 as usize] = 0.0;
		}
		for l81 in 0..2 {
			self.fRec76[l81 as usize] = 0.0;
		}
		for l82 in 0..2 {
			self.fRec79[l82 as usize] = 0.0;
		}
		for l83 in 0..2 {
			self.fRec78[l83 as usize] = 0.0;
		}
		for l84 in 0..2 {
			self.fRec77[l84 as usize] = 0.0;
		}
		for l85 in 0..2 {
			self.fRec80[l85 as usize] = 0.0;
		}
		for l86 in 0..2 {
			self.fRec83[l86 as usize] = 0.0;
		}
		for l87 in 0..2 {
			self.fRec82[l87 as usize] = 0.0;
		}
		for l88 in 0..2 {
			self.fRec81[l88 as usize] = 0.0;
		}
		for l89 in 0..2 {
			self.fRec86[l89 as usize] = 0.0;
		}
		for l90 in 0..2 {
			self.fRec85[l90 as usize] = 0.0;
		}
		for l91 in 0..2 {
			self.fRec84[l91 as usize] = 0.0;
		}
		for l92 in 0..2 {
			self.iRec92[l92 as usize] = 0;
		}
		for l93 in 0..2 {
			self.fRec91[l93 as usize] = 0.0;
		}
		for l94 in 0..2 {
			self.fRec89[l94 as usize] = 0.0;
		}
		for l95 in 0..2 {
			self.fRec90[l95 as usize] = 0.0;
		}
		for l96 in 0..3 {
			self.fRec88[l96 as usize] = 0.0;
		}
		for l97 in 0..3 {
			self.fRec87[l97 as usize] = 0.0;
		}
		for l98 in 0..2 {
			self.fRec94[l98 as usize] = 0.0;
		}
		for l99 in 0..5 {
			self.fRec93[l99 as usize] = 0.0;
		}
		for l100 in 0..5 {
			self.fRec95[l100 as usize] = 0.0;
		}
		for l101 in 0..2 {
			self.iRec96[l101 as usize] = 0;
		}
		for l102 in 0..3 {
			self.fRec98[l102 as usize] = 0.0;
		}
		for l103 in 0..3 {
			self.fRec97[l103 as usize] = 0.0;
		}
		for l104 in 0..2 {
			self.fVec13[l104 as usize] = 0.0;
		}
		for l105 in 0..2 {
			self.fRec99[l105 as usize] = 0.0;
		}
		for l106 in 0..1024 {
			self.fVec14[l106 as usize] = 0.0;
		}
		for l107 in 0..2 {
			self.fRec17[l107 as usize] = 0.0;
		}
		for l108 in 0..2 {
			self.fRec15[l108 as usize] = 0.0;
		}
		for l109 in 0..2 {
			self.fRec13[l109 as usize] = 0.0;
		}
		for l110 in 0..2 {
			self.fRec12[l110 as usize] = 0.0;
		}
		for l111 in 0..3 {
			self.fRec7[l111 as usize] = 0.0;
		}
		for l112 in 0..3 {
			self.fRec6[l112 as usize] = 0.0;
		}
		for l113 in 0..3 {
			self.fRec5[l113 as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, (self.fSampleRate) as F32));
		self.fConst1 = 0.02 * self.fConst0;
		self.fConst2 = 0.001 * self.fConst0;
		self.fConst3 = F32::exp(-(1e+02 / self.fConst0));
		self.fConst4 = 1.0 / F32::max(1.0, self.fConst2);
		self.fConst5 = 0.475 * self.fConst0;
		self.fConst6 = 3.1415927 / self.fConst0;
		self.fConst7 = 6283.1855 / self.fConst0;
		self.fConst8 = 1570.7964 / self.fConst0;
		self.fConst9 = 3141.5928 / self.fConst0;
		self.fConst10 = 0.00015 * self.fConst0;
		self.fConst11 = F32::max(1.0, self.fConst10);
		self.fConst12 = 1.0 / self.fConst11;
		self.fConst13 = 62.831852 / self.fConst0;
		self.fConst14 = 1.0 - self.fConst13;
		self.fConst15 = 0.0029411765 * self.fConst0;
		self.fConst16 = 1.867647e-05 * self.fConst0;
		self.fConst17 = 117.123 / self.fConst0;
		self.fConst18 = 4.4e+02 / self.fConst0;
		self.fConst19 = F32::exp(-(1e+03 / self.fConst0));
		self.fConst20 = 1.0 / self.fConst0;
		self.fConst21 = 1.0 - self.fConst19;
		self.fConst22 = 7539.8223 / self.fConst0;
		self.fConst23 = 15079.645 / self.fConst0;
		self.fConst24 = 3769.9111 / self.fConst0;
		self.fConst25 = 5974.9067 / self.fConst0;
		self.fConst26 = F32::exp(-(5e+01 / self.fConst0));
		self.fConst27 = 1.0 - self.fConst26;
		self.fConst28 = 5e+03 / self.fConst0;
		self.fConst29 = F32::min(4.8e+04, self.fConst0);
		self.fConst30 = F32::round(self.fConst0 / self.fConst29);
		self.fConst31 = self.fConst0 / F32::min(self.fConst29, self.fConst0);
		self.iConst32 = (self.fConst31) as i32;
		self.fConst33 = 9613.273 / self.fConst0;
		self.fConst34 = 6675.8843 / self.fConst0;
		self.fConst35 = 4.0 * DSP_Snare_faustpower2_f(self.fConst0);
		self.fConst36 = 0.5 / self.fConst0;
		self.fConst37 = 2.0 * self.fConst0;
		self.fConst38 = DSP_Snare_faustpower2_f(self.fConst20);
		self.fConst39 = DSP_Snare_faustpower4_f(self.fConst20);
		self.fConst40 = DSP_Snare_faustpower3_f(self.fConst20);
		self.fConst41 = 2.828427 * self.fConst40;
		self.fConst42 = 11.313708 / self.fConst0;
		self.fConst43 = 5.656854 * self.fConst40;
		self.fConst44 = 22.627417 / self.fConst0;
		self.fConst45 = 4.0 * self.fConst39;
		self.fConst46 = 6.0 * self.fConst39;
		self.fConst47 = 4806.6367 / self.fConst0;
		self.fConst48 = 3337.9421 / self.fConst0;
		self.fConst49 = 0.31622776 * self.fConst38;
		self.fConst50 = 0.003 * self.fConst0;
		self.fConst51 = 0.005 * self.fConst0;
		self.fConst52 = 1.0 / (self.fConst13 + 1.0);
		self.fConst53 = 1.0 / F32::tan(125.663704 / self.fConst0);
		self.fConst54 = 1.0 - self.fConst53;
		self.fConst55 = 1.0 / (self.fConst53 + 1.0);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Snare::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("OneTrick URCHIN DSP");
		ui_interface.add_num_entry("GainAdjustment", ParamIndex(0), 0.0, -1e+02, 12.0, 0.1);
		ui_interface.add_num_entry("PitchWheel", ParamIndex(1), 0.0, -1.0, 1.0, 0.001);
		ui_interface.add_num_entry("Transpose", ParamIndex(2), 0.0, -12.0, 12.0, 0.001);
		ui_interface.add_num_entry("Trigger", ParamIndex(3), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_button("WakeUp", ParamIndex(4));
		ui_interface.declare(Some(ParamIndex(5)), "050", "");
		ui_interface.add_horizontal_slider("Strike_Rimshot", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(6)), "070", "");
		ui_interface.declare(Some(ParamIndex(6)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(6)), "unit", "Hz");
		ui_interface.add_horizontal_slider("Tuning", ParamIndex(6), 1.2e+02, 4e+01, 2.4e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(7)), "090", "");
		ui_interface.declare(Some(ParamIndex(7)), "export", "Shell Depth");
		ui_interface.declare(Some(ParamIndex(7)), "unit", "in");
		ui_interface.add_horizontal_slider("Shell_Depth", ParamIndex(7), 12.0, 5.0, 24.0, 0.01);
		ui_interface.declare(Some(ParamIndex(8)), "1010", "");
		ui_interface.declare(Some(ParamIndex(8)), "export", "Lateness");
		ui_interface.declare(Some(ParamIndex(8)), "unit", "ms");
		ui_interface.add_horizontal_slider("Lateness", ParamIndex(8), 0.0, 0.0, 2e+01, 0.01);
		ui_interface.declare(Some(ParamIndex(9)), "1020", "");
		ui_interface.declare(Some(ParamIndex(9)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(9)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(9), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(10)), "1030", "");
		ui_interface.declare(Some(ParamIndex(10)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(10)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(10), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(11)), "1050", "");
		ui_interface.declare(Some(ParamIndex(11)), "export", "Reverb Send");
		ui_interface.declare(Some(ParamIndex(11)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(11), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(12)), "1060", "");
		ui_interface.declare(Some(ParamIndex(12)), "export", "Voice Punchiness");
		ui_interface.declare(Some(ParamIndex(12)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Punchiness", ParamIndex(12), 0.0, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(13)), "1070", "");
		ui_interface.declare(Some(ParamIndex(13)), "export", "Cutoff");
		ui_interface.declare(Some(ParamIndex(13)), "unit", "kHz");
		ui_interface.add_horizontal_slider("Sample_Cutoff", ParamIndex(13), 2e+01, 2.0, 2e+01, 0.01);
		ui_interface.declare(Some(ParamIndex(14)), "1080", "");
		ui_interface.declare(Some(ParamIndex(14)), "export", "Sample ToneFreq");
		ui_interface.declare(Some(ParamIndex(14)), "unit", "kHz");
		ui_interface.add_horizontal_slider("Sample_ToneFreq", ParamIndex(14), 1.5, 1.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(15)), "1090", "");
		ui_interface.declare(Some(ParamIndex(15)), "export", "Sample ToneGain");
		ui_interface.declare(Some(ParamIndex(15)), "unit", "db");
		ui_interface.add_horizontal_slider("Sample_ToneGain", ParamIndex(15), 0.0, 0.0, 6.0, 0.01);
		ui_interface.declare(Some(ParamIndex(16)), "110", "");
		ui_interface.declare(Some(ParamIndex(16)), "export", "Shell Damp");
		ui_interface.declare(Some(ParamIndex(16)), "unit", "%");
		ui_interface.add_horizontal_slider("Shell_Damp", ParamIndex(16), 3e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(17)), "1160", "");
		ui_interface.declare(Some(ParamIndex(17)), "export", "Sample Length");
		ui_interface.declare(Some(ParamIndex(17)), "minlabel", "∞");
		ui_interface.declare(Some(ParamIndex(17)), "unit", "s");
		ui_interface.add_horizontal_slider("Sample_Length", ParamIndex(17), 0.0, 0.0, 3.0, 0.01);
		ui_interface.declare(Some(ParamIndex(18)), "1165", "");
		ui_interface.declare(Some(ParamIndex(18)), "export", "Sample Speed");
		ui_interface.declare(Some(ParamIndex(18)), "unit", "st");
		ui_interface.add_horizontal_slider("Sample_Speed", ParamIndex(18), 0.0, -12.0, 12.0, 0.001);
		ui_interface.declare(Some(ParamIndex(19)), "1170", "");
		ui_interface.declare(Some(ParamIndex(19)), "export", "Mix Strike");
		ui_interface.declare(Some(ParamIndex(19)), "unit", "%");
		ui_interface.add_horizontal_slider("Mix_Strike", ParamIndex(19), 1e+02, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(20)), "1180", "");
		ui_interface.declare(Some(ParamIndex(20)), "export", "Strike Brightness");
		ui_interface.declare(Some(ParamIndex(20)), "unit", "%");
		ui_interface.add_horizontal_slider("Strike_Brightness", ParamIndex(20), 75.0, 0.0, 1e+02, 0.001);
		ui_interface.declare(Some(ParamIndex(21)), "120", "");
		ui_interface.declare(Some(ParamIndex(21)), "export", "Reso Tuning");
		ui_interface.declare(Some(ParamIndex(21)), "unit", "st");
		ui_interface.add_horizontal_slider("Reso_Tuning", ParamIndex(21), 0.0, -6.0, 6.0, 0.01);
		ui_interface.declare(Some(ParamIndex(22)), "130", "");
		ui_interface.declare(Some(ParamIndex(22)), "export", "Decay");
		ui_interface.declare(Some(ParamIndex(22)), "unit", "s");
		ui_interface.add_horizontal_slider("Decay", ParamIndex(22), 0.5, 0.15, 5.0, 0.0001);
		ui_interface.declare(Some(ParamIndex(23)), "140", "");
		ui_interface.declare(Some(ParamIndex(23)), "export", "Beater Damp");
		ui_interface.declare(Some(ParamIndex(23)), "unit", "%");
		ui_interface.add_horizontal_slider("Beater_Dampening", ParamIndex(23), 5e+01, 0.0, 1e+02, 0.0001);
		ui_interface.declare(Some(ParamIndex(24)), "160", "");
		ui_interface.declare(Some(ParamIndex(24)), "export", "Reso Head");
		ui_interface.declare(Some(ParamIndex(24)), "type", "bool");
		ui_interface.add_horizontal_slider("Reso_Head", ParamIndex(24), 1.0, 0.0, 1.0, 1.0);
		ui_interface.declare(Some(ParamIndex(25)), "200", "");
		ui_interface.declare(Some(ParamIndex(25)), "export", "Mix Ring");
		ui_interface.declare(Some(ParamIndex(25)), "unit", "%");
		ui_interface.add_horizontal_slider("Mix_Ring", ParamIndex(25), 35.0, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(26)), "210", "");
		ui_interface.declare(Some(ParamIndex(26)), "export", "Mix Reso");
		ui_interface.declare(Some(ParamIndex(26)), "unit", "%");
		ui_interface.add_horizontal_slider("Mix_Reso", ParamIndex(26), 1e+02, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(27)), "250", "");
		ui_interface.declare(Some(ParamIndex(27)), "export", "Detune Range");
		ui_interface.declare(Some(ParamIndex(27)), "unit", "st");
		ui_interface.add_horizontal_slider("Detune_Range", ParamIndex(27), 8.0, 0.0, 32.0, 0.001);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			4 => Some(self.fButton0),
			3 => Some(self.fEntry0),
			1 => Some(self.fEntry1),
			2 => Some(self.fEntry2),
			0 => Some(self.fEntry3),
			8 => Some(self.fHslider0),
			18 => Some(self.fHslider1),
			5 => Some(self.fHslider10),
			25 => Some(self.fHslider11),
			27 => Some(self.fHslider12),
			21 => Some(self.fHslider13),
			6 => Some(self.fHslider14),
			26 => Some(self.fHslider15),
			24 => Some(self.fHslider16),
			23 => Some(self.fHslider17),
			20 => Some(self.fHslider18),
			19 => Some(self.fHslider19),
			17 => Some(self.fHslider2),
			10 => Some(self.fHslider20),
			9 => Some(self.fHslider21),
			11 => Some(self.fHslider22),
			13 => Some(self.fHslider3),
			15 => Some(self.fHslider4),
			14 => Some(self.fHslider5),
			12 => Some(self.fHslider6),
			16 => Some(self.fHslider7),
			7 => Some(self.fHslider8),
			22 => Some(self.fHslider9),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			4 => { self.fButton0 = value }
			3 => { self.fEntry0 = value }
			1 => { self.fEntry1 = value }
			2 => { self.fEntry2 = value }
			0 => { self.fEntry3 = value }
			8 => { self.fHslider0 = value }
			18 => { self.fHslider1 = value }
			5 => { self.fHslider10 = value }
			25 => { self.fHslider11 = value }
			27 => { self.fHslider12 = value }
			21 => { self.fHslider13 = value }
			6 => { self.fHslider14 = value }
			26 => { self.fHslider15 = value }
			24 => { self.fHslider16 = value }
			23 => { self.fHslider17 = value }
			20 => { self.fHslider18 = value }
			19 => { self.fHslider19 = value }
			17 => { self.fHslider2 = value }
			10 => { self.fHslider20 = value }
			9 => { self.fHslider21 = value }
			11 => { self.fHslider22 = value }
			13 => { self.fHslider3 = value }
			15 => { self.fHslider4 = value }
			14 => { self.fHslider5 = value }
			12 => { self.fHslider6 = value }
			16 => { self.fHslider7 = value }
			7 => { self.fHslider8 = value }
			22 => { self.fHslider9 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut iSlow1: i32 = (F32::min(self.fConst1, F32::max(0.0, self.fConst2 * self.fHslider0))) as i32;
		let mut fSlow2: F32 = self.fButton0;
		let mut fSlow3: F32 = self.fHslider1 + self.fEntry2 + 12.0 * self.fEntry1;
		let mut fSlow4: F32 = self.fHslider2;
		let mut fSlow5: F32 = self.fConst0 * fSlow4;
		let mut fSlow6: F32 = ((fSlow4 > 0.0) as i32) as u32 as F32;
		let mut fSlow7: F32 = 1e+03 * self.fHslider3;
		let mut fSlow8: F32 = self.fHslider4;
		let mut iSlow9: i32 = (fSlow8 > 0.0) as i32;
		let mut fSlow10: F32 = self.fHslider5;
		let mut fSlow11: F32 = F32::sin(self.fConst7 * fSlow10);
		let mut fSlow12: F32 = self.fConst8 * (fSlow10 * F32::powf(1e+01, 0.05 * F32::abs(fSlow8)) / fSlow11);
		let mut fSlow13: F32 = self.fConst8 * (fSlow10 / fSlow11);
		let mut fSlow14: F32 = if iSlow9 != 0 {fSlow13} else {fSlow12};
		let mut fSlow15: F32 = F32::tan(self.fConst9 * fSlow10);
		let mut fSlow16: F32 = 1.0 / fSlow15;
		let mut fSlow17: F32 = fSlow16 * (fSlow16 + fSlow14) + 1.0;
		let mut fSlow18: F32 = if iSlow9 != 0 {fSlow12} else {fSlow13};
		let mut fSlow19: F32 = fSlow16 * (fSlow16 - fSlow18) + 1.0;
		let mut fSlow20: F32 = 2.0 * (1.0 - 1.0 / DSP_Snare_faustpower2_f(fSlow15));
		let mut fSlow21: F32 = fSlow16 * (fSlow16 - fSlow14) + 1.0;
		let mut fSlow22: F32 = 0.01 * self.fHslider6;
		let mut fSlow23: F32 = 1.0 - 0.009999 * self.fHslider7;
		let mut fSlow24: F32 = self.fHslider8;
		let mut fSlow25: F32 = self.fConst16 * fSlow24;
		let mut fSlow26: F32 = fSlow24 + -5.0;
		let mut fSlow27: F32 = self.fConst18 * F32::powf(2.0, 0.083333336 * (8.283786 - 0.31951007 * fSlow26));
		let mut fSlow28: F32 = self.fHslider9;
		let mut fSlow29: F32 = 0.125 * fSlow28;
		let mut fSlow30: F32 = self.fHslider10;
		let mut fSlow31: F32 = 0.01 * self.fHslider11 * F32::powf(1e+01, -(0.031578947 * fSlow26)) * F32::powf(1e+01, 0.05 * (9.0 * fSlow30 + -34.0));
		let mut fSlow32: F32 = 0.25 * fSlow28;
		let mut fSlow33: F32 = 0.083333336 * self.fHslider12;
		let mut fSlow34: F32 = self.fHslider14;
		let mut fSlow35: F32 = fSlow34 * F32::powf(2.0, 0.083333336 * self.fHslider13);
		let mut fSlow36: F32 = 0.25 * fSlow28 * fSlow34;
		let mut fSlow37: F32 = self.fHslider15;
		let mut fSlow38: F32 = 0.002 * (1.0 - 0.005 * fSlow37);
		let mut fSlow39: F32 = 0.01 * fSlow37;
		let mut fSlow40: F32 = self.fHslider16 * fSlow37;
		let mut fSlow41: F32 = 0.25 * fSlow28 * (1.0 - 0.008 * self.fHslider17);
		let mut fSlow42: F32 = self.fConst6 * (4.4e+03 - 152.63158 * fSlow26);
		let mut fSlow43: F32 = self.fConst6 * (3e+03 - 105.26316 * fSlow26);
		let mut fSlow44: F32 = self.fHslider18;
		let mut fSlow45: F32 = 0.0067 * fSlow44 + 0.33;
		let mut fSlow46: F32 = self.fConst49 * fSlow30;
		let mut fSlow47: F32 = 4.4e+02 * F32::powf(2.0, 0.083333336 * (0.5186314 * fSlow44 + 2.213095));
		let mut fSlow48: F32 = 4.4e+02 * F32::powf(2.0, 0.083333336 * (0.3101955 * fSlow44 + -41.51318));
		let mut fSlow49: F32 = F32::powf(1e+01, 0.05 * (-12.0 - 0.09 * fSlow44));
		let mut fSlow50: F32 = self.fHslider19;
		let mut fSlow51: F32 = fSlow16 * (fSlow16 + fSlow18) + 1.0;
		let mut fSlow52: F32 = 0.01 * self.fHslider20;
		let mut fSlow53: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fEntry3 + self.fHslider21 + 6.0));
		let mut fSlow54: F32 = 0.5 * fSlow53 * F32::min(1.0, 1.0 - fSlow52);
		let mut fSlow55: F32 = 0.5 * fSlow53 * F32::min(1.0, fSlow52 + 1.0);
		let mut fSlow56: F32 = 0.005 * self.fHslider22 * fSlow53;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[(self.IOTA0 & 4095) as usize] = fSlow0;
			let mut fTemp0: F32 = self.fVec1[((i32::wrapping_sub(self.IOTA0, iSlow1)) & 4095) as usize];
			self.fVec2[0] = fTemp0;
			let mut iTemp1: i32 = (fTemp0 > self.fVec2[1]) as i32;
			self.iVec3[0] = iTemp1;
			let mut iTemp2: i32 = (iTemp1 > 0) as i32;
			self.fVec4[0] = fSlow2;
			let mut fTemp3: F32 = ((fSlow2 <= self.fVec4[1]) as i32) as u32 as F32;
			let mut fTemp4: F32 = 1.0 - self.fConst3 * fTemp3;
			self.fRec2[0] = fSlow3 * fTemp4 + self.fConst3 * fTemp3 * self.fRec2[1];
			let mut fTemp5: F32 = F32::powf(2.0, 0.083333336 * self.fRec2[0]);
			self.fRec1[0] = if iTemp2 != 0 {fSlow5 / fTemp5} else {F32::max(0.0, self.fRec1[1] + -1.0)};
			let mut iTemp6: i32 = (self.fRec1[0] > 0.0) as i32;
			self.iVec5[0] = iTemp6;
			self.iRec0[0] = ((iTemp6 == 0) as i32) * (i32::wrapping_add(self.iRec0[1], 1));
			self.iRec3[0] = i32::wrapping_add(iTemp6, i32::wrapping_mul(self.iRec3[1], (self.iVec5[1] >= iTemp6) as i32));
			self.fRec4[0] = fSlow6 * fTemp4 + self.fConst3 * fTemp3 * self.fRec4[1];
			let mut fTemp7: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, fSlow7 * fTemp5));
			let mut fTemp8: F32 = 1.0 / fTemp7;
			let mut fTemp9: F32 = (fTemp8 + 0.76536685) / fTemp7 + 1.0;
			let mut fTemp10: F32 = 1.0 - 1.0 / DSP_Snare_faustpower2_f(fTemp7);
			let mut fTemp11: F32 = (fTemp8 + 1.847759) / fTemp7 + 1.0;
			let mut fTemp12: F32 = fSlow20 * self.fRec7[1];
			let mut iTemp13: i32 = (iTemp1 > self.iVec3[1]) as i32;
			self.iVec6[0] = iTemp13;
			self.fRec8[0] = if (iTemp13 > 0) as i32 != 0 {self.fConst10} else {F32::max(0.0, self.fRec8[1] + -1.0)};
			self.iRec9[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec9[1], (self.iRec9[1] > 0) as i32), (iTemp13 <= self.iVec6[1]) as i32), (iTemp13 > self.iVec6[1]) as i32);
			let mut fTemp14: F32 = (self.iRec9[0]) as F32;
			self.fRec10[0] = fSlow22 * fTemp4 + self.fConst3 * fTemp3 * self.fRec10[1];
			let mut fTemp15: F32 = F32::max(0.0, F32::min(self.fConst12 * fTemp14, (self.fConst11 - fTemp14) / F32::max(1.0, self.fConst0 * ((0.5 - 0.35 * self.fRec10[0]) / fTemp5)) + 1.0));
			self.fVec7[0] = fTemp15;
			self.fRec11[0] = if iTemp13 != 0 {self.fVec7[1]} else {self.fRec11[1]};
			self.iRec14[0] = 0;
			self.fRec18[0] = fSlow23 * fTemp4 + self.fConst3 * fTemp3 * self.fRec18[1];
			let mut fTemp16: F32 = F32::max(0.01, self.fRec18[0]);
			self.fRec19[0] = 0.08 * self.fRec17[1] + 0.92 * self.fRec19[1];
			let mut fTemp17: F32 = self.fRec19[0] * fTemp16 + (self.iRec14[1]) as F32;
			self.fVec8[(self.IOTA0 & 1023) as usize] = fTemp17;
			let mut fTemp18: F32 = fSlow25 / fTemp5;
			let mut fTemp19: F32 = fTemp18 + -1.499995;
			let mut iTemp20: i32 = (fTemp19) as i32;
			let mut iTemp21: i32 = (F32::min(self.fConst15, (std::cmp::max(0, i32::wrapping_add(iTemp20, 4))) as F32)) as i32;
			let mut fTemp22: F32 = F32::floor(fTemp19);
			let mut fTemp23: F32 = fTemp18 + (-3.0 - fTemp22);
			let mut fTemp24: F32 = fTemp18 + (-2.0 - fTemp22);
			let mut fTemp25: F32 = fTemp18 + (-1.0 - fTemp22);
			let mut fTemp26: F32 = fTemp18 - fTemp22;
			let mut fTemp27: F32 = fTemp26 * fTemp25;
			let mut fTemp28: F32 = fTemp27 * fTemp24;
			let mut fTemp29: F32 = fTemp28 * fTemp23;
			let mut iTemp30: i32 = (F32::min(self.fConst15, (std::cmp::max(0, i32::wrapping_add(iTemp20, 3))) as F32)) as i32;
			let mut iTemp31: i32 = (F32::min(self.fConst15, (std::cmp::max(0, i32::wrapping_add(iTemp20, 2))) as F32)) as i32;
			let mut iTemp32: i32 = (F32::min(self.fConst15, (std::cmp::max(0, i32::wrapping_add(iTemp20, 1))) as F32)) as i32;
			let mut iTemp33: i32 = (F32::min(self.fConst15, (std::cmp::max(0, iTemp20)) as F32)) as i32;
			let mut fTemp34: F32 = fTemp18 + (-4.0 - fTemp22);
			self.fRec16[0] = fTemp34 * (fTemp23 * (fTemp24 * (0.041666668 * self.fVec8[((i32::wrapping_sub(self.IOTA0, iTemp33)) & 1023) as usize] * fTemp25 - 0.16666667 * fTemp26 * self.fVec8[((i32::wrapping_sub(self.IOTA0, iTemp32)) & 1023) as usize]) + 0.25 * fTemp27 * self.fVec8[((i32::wrapping_sub(self.IOTA0, iTemp31)) & 1023) as usize]) - 0.16666667 * fTemp28 * self.fVec8[((i32::wrapping_sub(self.IOTA0, iTemp30)) & 1023) as usize]) + 0.041666668 * fTemp29 * self.fVec8[((i32::wrapping_sub(self.IOTA0, iTemp21)) & 1023) as usize];
			let mut iTemp35: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp36: F32 = if iTemp35 != 0 {0.0} else {self.fConst17 + self.fRec22[1]};
			self.fRec22[0] = fTemp36 - F32::floor(fTemp36);
			let mut fTemp37: F32 = if iTemp35 != 0 {0.0} else {self.fRec21[1] + fSlow27 * fTemp5 * (0.25 * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec22[0]) as i32) as usize] } + 1.0)};
			self.fRec21[0] = fTemp37 - F32::floor(fTemp37);
			let mut fTemp38: F32 = (i32::wrapping_sub(1, iTemp13)) as F32;
			let mut fTemp39: F32 = fSlow29 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec24[1]) - 1.0) + 1.75) / fTemp5);
			let mut iTemp40: i32 = (F32::abs(fTemp39) < 1.1920929e-07) as i32;
			let mut fTemp41: F32 = if iTemp40 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp40 != 0 {1.0} else {fTemp39}))};
			self.fRec26[0] = if iTemp1 != 0 {0.99 * fTemp0 + 0.01} else {self.fRec26[1]};
			let mut fTemp42: F32 = DSP_Snare_faustpower3_f(self.fRec26[0]);
			let mut fTemp43: F32 = (iTemp13) as F32;
			self.fRec25[0] = fTemp43 * (1.0 - fTemp41) * F32::min(1.0, F32::max(self.fRec24[1] + 0.5 * fTemp42, fTemp42)) + fTemp41 * self.fRec25[1];
			self.fRec24[0] = self.fRec25[0];
			self.fRec23[0] = self.fConst21 * self.fRec24[0] + self.fConst19 * self.fRec23[1];
			let mut fTemp44: F32 = fSlow32 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec28[1]) - 1.0) + 1.75) / fTemp5);
			let mut iTemp45: i32 = (F32::abs(fTemp44) < 1.1920929e-07) as i32;
			let mut fTemp46: F32 = if iTemp45 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp45 != 0 {1.0} else {fTemp44}))};
			let mut fTemp47: F32 = 0.5 * self.fRec26[0];
			self.fRec29[0] = fTemp43 * (1.0 - fTemp46) * F32::min(1.0, F32::max(fTemp47 + self.fRec28[1], self.fRec26[0])) + fTemp46 * self.fRec29[1];
			self.fRec28[0] = self.fRec29[0];
			self.fRec27[0] = self.fConst21 * self.fRec28[0] + self.fConst19 * self.fRec27[1];
			let mut fTemp48: F32 = F32::max(4e+01, fSlow35 * fTemp5 * F32::powf(2.0, fSlow33 * F32::max(0.0, 1.1764706 * (self.fRec27[0] + -0.15))));
			let mut fTemp49: F32 = fTemp48 + -2e+01;
			let mut fTemp50: F32 = 5.0 * fTemp49 + 2e+01;
			let mut fTemp51: F32 = if iTemp35 != 0 {0.0} else {self.fRec30[1] + self.fConst20 * fTemp50};
			self.fRec30[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = fSlow36 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec32[1]) - 1.0) + 1.75) / fTemp50);
			let mut iTemp53: i32 = (F32::abs(fTemp52) < 1.1920929e-07) as i32;
			let mut fTemp54: F32 = if iTemp53 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp53 != 0 {1.0} else {fTemp52}))};
			let mut fTemp55: F32 = self.fRec26[0] * F32::powf(1e+01, -(0.7 * (1.0 - self.fRec26[0])));
			let mut fTemp56: F32 = 0.5 * fTemp55;
			self.fRec33[0] = fTemp43 * (1.0 - fTemp54) * F32::min(1.0, F32::max(fTemp56 + self.fRec32[1], fTemp55)) + fTemp54 * self.fRec33[1];
			self.fRec32[0] = self.fRec33[0];
			self.fRec31[0] = self.fConst21 * self.fRec32[0] + self.fConst19 * self.fRec31[1];
			let mut fTemp57: F32 = 3.0 * fTemp49 + 2e+01;
			let mut fTemp58: F32 = if iTemp35 != 0 {0.0} else {self.fRec34[1] + self.fConst20 * fTemp57};
			self.fRec34[0] = fTemp58 - F32::floor(fTemp58);
			let mut fTemp59: F32 = fSlow36 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec36[1]) - 1.0) + 1.75) / fTemp57);
			let mut iTemp60: i32 = (F32::abs(fTemp59) < 1.1920929e-07) as i32;
			let mut fTemp61: F32 = if iTemp60 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp60 != 0 {1.0} else {fTemp59}))};
			self.fRec37[0] = fTemp43 * (1.0 - fTemp61) * F32::min(1.0, F32::max(fTemp56 + self.fRec36[1], fTemp55)) + fTemp61 * self.fRec37[1];
			self.fRec36[0] = self.fRec37[0];
			self.fRec35[0] = self.fConst21 * self.fRec36[0] + self.fConst19 * self.fRec35[1];
			let mut fTemp62: F32 = if iTemp35 != 0 {0.0} else {self.fRec38[1] + self.fConst20 * fTemp48};
			self.fRec38[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = fSlow36 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec40[1]) - 1.0) + 1.75) / fTemp48);
			let mut iTemp64: i32 = (F32::abs(fTemp63) < 1.1920929e-07) as i32;
			let mut fTemp65: F32 = if iTemp64 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp64 != 0 {1.0} else {fTemp63}))};
			self.fRec41[0] = fTemp43 * (1.0 - fTemp65) * F32::min(1.0, F32::max(self.fRec40[1] + fTemp56, fTemp55)) + fTemp65 * self.fRec41[1];
			self.fRec40[0] = self.fRec41[0];
			self.fRec39[0] = self.fConst21 * self.fRec40[0] + self.fConst19 * self.fRec39[1];
			let mut fTemp66: F32 = 4.0 * fTemp49 + 2e+01;
			let mut fTemp67: F32 = if iTemp35 != 0 {0.0} else {self.fRec42[1] + self.fConst20 * fTemp66};
			self.fRec42[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow36 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec44[1]) - 1.0) + 1.75) / fTemp66);
			let mut iTemp69: i32 = (F32::abs(fTemp68) < 1.1920929e-07) as i32;
			let mut fTemp70: F32 = if iTemp69 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp69 != 0 {1.0} else {fTemp68}))};
			self.fRec45[0] = fTemp43 * (1.0 - fTemp70) * F32::min(1.0, F32::max(fTemp56 + self.fRec44[1], fTemp55)) + fTemp70 * self.fRec45[1];
			self.fRec44[0] = self.fRec45[0];
			self.fRec43[0] = self.fConst21 * self.fRec44[0] + self.fConst19 * self.fRec43[1];
			let mut fTemp71: F32 = 2.0 * fTemp49 + 2e+01;
			let mut fTemp72: F32 = if iTemp35 != 0 {0.0} else {self.fRec46[1] + self.fConst20 * fTemp71};
			self.fRec46[0] = fTemp72 - F32::floor(fTemp72);
			let mut fTemp73: F32 = fSlow36 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec48[1]) - 1.0) + 1.75) / fTemp71);
			let mut iTemp74: i32 = (F32::abs(fTemp73) < 1.1920929e-07) as i32;
			let mut fTemp75: F32 = if iTemp74 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp74 != 0 {1.0} else {fTemp73}))};
			self.fRec49[0] = fTemp43 * (1.0 - fTemp75) * F32::min(1.0, F32::max(fTemp56 + self.fRec48[1], fTemp55)) + fTemp75 * self.fRec49[1];
			self.fRec48[0] = self.fRec49[0];
			self.fRec47[0] = self.fConst21 * self.fRec48[0] + self.fConst19 * self.fRec47[1];
			let mut fTemp76: F32 = self.fRec47[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec46[0]) as i32) as usize] } * F32::powf(fTemp48 / fTemp71, 1.6) + self.fRec43[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec42[0]) as i32) as usize] } * F32::powf(fTemp48 / fTemp66, 1.6) - (self.fRec39[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec38[0]) as i32) as usize] } + self.fRec35[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec34[0]) as i32) as usize] } * F32::powf(fTemp48 / fTemp57, 1.6) + self.fRec31[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec30[0]) as i32) as usize] } * F32::powf(fTemp48 / fTemp50, 1.6));
			let mut fTemp77: F32 = 1.0 / F32::tan(self.fConst6 * F32::min(self.fConst5, 7.5e+03 * fTemp5));
			let mut fTemp78: F32 = F32::tan(self.fConst22 * fTemp5);
			let mut fTemp79: F32 = fTemp5 / F32::sin(self.fConst23 * fTemp5);
			let mut fTemp80: F32 = self.fConst24 * fTemp79;
			let mut fTemp81: F32 = 1.0 / fTemp78;
			let mut fTemp82: F32 = (fTemp81 + fTemp80) / fTemp78 + 1.0;
			let mut fTemp83: F32 = self.fConst25 * fTemp79;
			let mut fTemp84: F32 = 2.0 * self.fRec51[1] * (1.0 - 1.0 / DSP_Snare_faustpower2_f(fTemp78));
			self.iRec52[0] = i32::wrapping_add(i32::wrapping_mul(1103515245, self.iRec52[1]), 12345);
			let mut fTemp85: F32 = (self.iRec52[0]) as F32;
			self.fVec10[0] = fTemp85;
			let mut fRec58: F32 = F32::abs(0.2 * fTemp76);
			self.iRec59[0] = std::cmp::max(0, i32::wrapping_add(self.iRec59[1], -1));
			let mut fTemp86: F32 = F32::abs(F32::max(((fRec58 > 0.004698941) as i32) as u32 as F32, ((self.iRec59[0] > 0) as i32) as u32 as F32));
			let mut fTemp87: F32 = if (fTemp86 > self.fRec57[1]) as i32 != 0 {0.0} else {self.fConst26};
			self.fRec57[0] = fTemp86 * (1.0 - fTemp87) + self.fRec57[1] * fTemp87;
			self.fRec56[0] = self.fConst27 * F32::abs(0.2 * self.fRec57[0] * fTemp76) + self.fConst26 * self.fRec56[1];
			let mut fTemp88: F32 = if iTemp35 != 0 {0.0} else {self.fRec55[1] + self.fConst28 * (self.fRec56[0] + 1.0)};
			self.fRec55[0] = fTemp88 - F32::floor(fTemp88);
			let mut fTemp89: F32 = self.fRec55[0] - self.fRec55[1];
			self.fVec11[0] = fTemp89;
			let mut iTemp90: i32 = ((self.fVec11[1] <= 0.0) as i32) & ((fTemp89 > 0.0) as i32);
			self.fRec54[0] = self.fRec54[1] * (i32::wrapping_sub(1, iTemp90)) as F32 + 4.656613e-10 * fTemp85 * (iTemp90) as F32;
			let mut fTemp91: F32 = 0.5 * (self.fRec54[0] + 1.0);
			let mut fTemp92: F32 = 4.656613e-10 * self.fVec10[1] * (((self.fRec55[0] >= fTemp91) as i32) * ((self.fRec55[1] < fTemp91) as i32)) as F32;
			let mut iTemp93: i32 = i32::abs(((fTemp92 > 0.0) as i32) - ((fTemp92 < 0.0) as i32));
			self.fRec53[0] = if (iTemp93 > 0) as i32 != 0 {self.fConst30} else {F32::max(0.0, self.fRec53[1] + -1.0)};
			self.fRec60[0] = if iTemp93 != 0 {fTemp92} else {self.fRec60[1]};
			let mut fTemp94: F32 = self.fRec60[0] * ((self.fRec53[0] > 0.0) as i32) as u32 as F32;
			self.fRec51[0] = fSlow39 * self.fRec56[0] * (((fTemp94 > 0.0) as i32) - ((fTemp94 < 0.0) as i32)) as F32 * (0.375 * (2.3283064e-10 * fTemp85 + 1.0) + 0.25) - (self.fRec51[2] * ((fTemp81 - fTemp80) / fTemp78 + 1.0) + fTemp84) / fTemp82;
			let mut fTemp95: F32 = (fTemp84 + self.fRec51[0] * ((fTemp81 + fTemp83) / fTemp78 + 1.0) + self.fRec51[2] * ((fTemp81 - fTemp83) / fTemp78 + 1.0)) / fTemp82;
			self.fVec12[0] = fTemp95;
			self.fRec50[0] = -((self.fRec50[1] * (1.0 - fTemp77) - (fTemp95 + self.fVec12[1])) / (fTemp77 + 1.0));
			let mut fTemp96: F32 = fSlow41 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec62[1]) - 1.0) + 1.75) / fTemp5);
			let mut iTemp97: i32 = (F32::abs(fTemp96) < 1.1920929e-07) as i32;
			let mut fTemp98: F32 = if iTemp97 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp97 != 0 {1.0} else {fTemp96}))};
			self.fRec63[0] = (1.0 - fTemp98) * F32::min(1.0, F32::max(self.fRec62[1] + fTemp47, self.fRec26[0])) * fTemp43 + fTemp98 * self.fRec63[1];
			self.fRec62[0] = self.fRec63[0];
			self.fRec61[0] = self.fConst21 * self.fRec62[0] + self.fConst19 * self.fRec61[1];
			let mut fTemp99: F32 = F32::max(4e+01, fSlow34 * fTemp5 * F32::powf(2.0, fSlow33 * F32::max(0.0, 1.1764706 * (self.fRec61[0] + -0.15))));
			let mut fTemp100: F32 = fTemp99 + -2e+01;
			let mut fTemp101: F32 = 5.0 * fTemp100 + 2e+01;
			let mut fTemp102: F32 = if iTemp35 != 0 {0.0} else {self.fRec64[1] + self.fConst20 * fTemp101};
			self.fRec64[0] = fTemp102 - F32::floor(fTemp102);
			let mut fTemp103: F32 = fTemp38 * fTemp99;
			let mut fTemp104: F32 = fSlow41 * (fTemp103 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec66[1]) - 1.0) + 1.75) / (fTemp5 * fTemp101));
			let mut iTemp105: i32 = (F32::abs(fTemp104) < 1.1920929e-07) as i32;
			let mut fTemp106: F32 = if iTemp105 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp105 != 0 {1.0} else {fTemp104}))};
			self.fRec67[0] = fTemp43 * (1.0 - fTemp106) * F32::min(1.0, F32::max(fTemp47 + self.fRec66[1], self.fRec26[0])) + fTemp106 * self.fRec67[1];
			self.fRec66[0] = self.fRec67[0];
			self.fRec65[0] = self.fConst21 * self.fRec66[0] + self.fConst19 * self.fRec65[1];
			let mut fTemp107: F32 = 3.0 * fTemp100 + 2e+01;
			let mut fTemp108: F32 = if iTemp35 != 0 {0.0} else {self.fRec68[1] + self.fConst20 * fTemp107};
			self.fRec68[0] = fTemp108 - F32::floor(fTemp108);
			let mut fTemp109: F32 = fSlow41 * (fTemp103 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec70[1]) - 1.0) + 1.75) / (fTemp5 * fTemp107));
			let mut iTemp110: i32 = (F32::abs(fTemp109) < 1.1920929e-07) as i32;
			let mut fTemp111: F32 = if iTemp110 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp110 != 0 {1.0} else {fTemp109}))};
			self.fRec71[0] = fTemp43 * (1.0 - fTemp111) * F32::min(1.0, F32::max(fTemp47 + self.fRec70[1], self.fRec26[0])) + fTemp111 * self.fRec71[1];
			self.fRec70[0] = self.fRec71[0];
			self.fRec69[0] = self.fConst21 * self.fRec70[0] + self.fConst19 * self.fRec69[1];
			let mut fTemp112: F32 = if iTemp35 != 0 {0.0} else {self.fRec72[1] + self.fConst20 * fTemp99};
			self.fRec72[0] = fTemp112 - F32::floor(fTemp112);
			let mut fTemp113: F32 = fSlow41 * (fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec74[1]) - 1.0) + 1.75) / fTemp5);
			let mut iTemp114: i32 = (F32::abs(fTemp113) < 1.1920929e-07) as i32;
			let mut fTemp115: F32 = if iTemp114 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp114 != 0 {1.0} else {fTemp113}))};
			self.fRec75[0] = fTemp43 * (1.0 - fTemp115) * F32::min(1.0, F32::max(fTemp47 + self.fRec74[1], self.fRec26[0])) + fTemp115 * self.fRec75[1];
			self.fRec74[0] = self.fRec75[0];
			self.fRec73[0] = self.fConst21 * self.fRec74[0] + self.fConst19 * self.fRec73[1];
			let mut fTemp116: F32 = 4.0 * fTemp100 + 2e+01;
			let mut fTemp117: F32 = if iTemp35 != 0 {0.0} else {self.fRec76[1] + self.fConst20 * fTemp116};
			self.fRec76[0] = fTemp117 - F32::floor(fTemp117);
			let mut fTemp118: F32 = fSlow41 * (fTemp103 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec78[1]) - 1.0) + 1.75) / (fTemp5 * fTemp116));
			let mut iTemp119: i32 = (F32::abs(fTemp118) < 1.1920929e-07) as i32;
			let mut fTemp120: F32 = if iTemp119 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp119 != 0 {1.0} else {fTemp118}))};
			self.fRec79[0] = fTemp43 * (1.0 - fTemp120) * F32::min(1.0, F32::max(fTemp47 + self.fRec78[1], self.fRec26[0])) + fTemp120 * self.fRec79[1];
			self.fRec78[0] = self.fRec79[0];
			self.fRec77[0] = self.fConst21 * self.fRec78[0] + self.fConst19 * self.fRec77[1];
			let mut fTemp121: F32 = 2.0 * fTemp100 + 2e+01;
			let mut fTemp122: F32 = if iTemp35 != 0 {0.0} else {self.fRec80[1] + self.fConst20 * fTemp121};
			self.fRec80[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = fSlow41 * (fTemp103 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec82[1]) - 1.0) + 1.75) / (fTemp5 * fTemp121));
			let mut iTemp124: i32 = (F32::abs(fTemp123) < 1.1920929e-07) as i32;
			let mut fTemp125: F32 = if iTemp124 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp124 != 0 {1.0} else {fTemp123}))};
			self.fRec83[0] = fTemp43 * (1.0 - fTemp125) * F32::min(1.0, F32::max(fTemp47 + self.fRec82[1], self.fRec26[0])) + fTemp125 * self.fRec83[1];
			self.fRec82[0] = self.fRec83[0];
			self.fRec81[0] = self.fConst21 * self.fRec82[0] + self.fConst19 * self.fRec81[1];
			let mut fTemp126: F32 = 0.0375 * fTemp38 * (1.7 * (DSP_Snare_faustpower3_f(1.0 - self.fRec85[1]) - 1.0) + 1.75);
			let mut iTemp127: i32 = (F32::abs(fTemp126) < 1.1920929e-07) as i32;
			let mut fTemp128: F32 = if iTemp127 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp127 != 0 {1.0} else {fTemp126}))};
			self.fRec86[0] = fTemp43 * (1.0 - fTemp128) * F32::min(1.0, F32::max(fTemp47 + self.fRec85[1], self.fRec26[0])) + fTemp128 * self.fRec86[1];
			self.fRec85[0] = self.fRec86[0];
			self.fRec84[0] = self.fConst21 * self.fRec85[0] + self.fConst19 * self.fRec84[1];
			let mut fTemp129: F32 = F32::tan(fSlow42 * fTemp5 * (0.3 * self.fRec26[0] + 0.8) * (0.2 * self.fRec84[0] + 0.8));
			let mut fTemp130: F32 = 1.0 / fTemp129;
			let mut fTemp131: F32 = (fTemp130 + 1.4142135) / fTemp129 + 1.0;
			let mut fTemp132: F32 = F32::tan(fSlow43 * fTemp5);
			let mut fTemp133: F32 = 1.0 / fTemp132;
			let mut fTemp134: F32 = (fTemp133 + 1.4142135) / fTemp132 + 1.0;
			let mut fTemp135: F32 = DSP_Snare_faustpower2_f(fTemp132);
			self.iRec92[0] = i32::wrapping_add(self.iRec92[1], 1);
			self.fRec91[0] = if (((i32::wrapping_add(self.iRec92[0], -1)) % self.iConst32) == 0) as i32 != 0 {4.656613e-10 * fTemp85} else {self.fRec91[1]};
			let mut fTemp136: F32 = if (self.fRec91[0] != self.fRec91[1]) as i32 != 0 {self.fConst31} else {self.fRec89[1] + -1.0};
			self.fRec89[0] = fTemp136;
			self.fRec90[0] = if (fTemp136 > 0.0) as i32 != 0 {self.fRec90[1] + (self.fRec91[0] - self.fRec90[1]) / fTemp136} else {self.fRec91[0]};
			self.fRec88[0] = fSlow45 * self.fRec90[0] * (0.29 * DSP_Snare_faustpower2_f(self.fRec26[0]) + 0.06) - (self.fRec88[2] * ((fTemp133 + -1.4142135) / fTemp132 + 1.0) + 2.0 * self.fRec88[1] * (1.0 - 1.0 / fTemp135)) / fTemp134;
			self.fRec87[0] = (self.fRec88[2] + (self.fRec88[0] - 2.0 * self.fRec88[1])) / (fTemp135 * fTemp134) - (self.fRec87[2] * ((fTemp130 + -1.4142135) / fTemp129 + 1.0) + 2.0 * self.fRec87[1] * (1.0 - 1.0 / DSP_Snare_faustpower2_f(fTemp129))) / fTemp131;
			let mut fTemp137: F32 = F32::tan(self.fConst33 * fTemp5);
			let mut fTemp138: F32 = F32::sqrt(self.fConst35 * F32::tan(self.fConst34 * fTemp5) * fTemp137);
			let mut fTemp139: F32 = DSP_Snare_faustpower2_f(fTemp138);
			let mut fTemp140: F32 = self.fConst37 * fTemp137 - self.fConst36 * (fTemp139 / fTemp137);
			let mut fTemp141: F32 = DSP_Snare_faustpower2_f(fTemp140);
			let mut fTemp142: F32 = DSP_Snare_faustpower4_f(fTemp138);
			let mut fTemp143: F32 = self.fConst39 * fTemp142 + self.fConst38 * (4.0 * fTemp141 + 8.0 * fTemp139);
			let mut fTemp144: F32 = fTemp140 * (self.fConst42 + self.fConst41 * fTemp139);
			let mut fTemp145: F32 = fTemp144 + fTemp143 + 16.0;
			let mut fTemp146: F32 = self.fConst43 * fTemp139;
			let mut fTemp147: F32 = self.fConst45 * fTemp142;
			let mut fTemp148: F32 = 0.1447178 * if iTemp2 != 0 {0.0} else {0.12 / fTemp5};
			let mut iTemp149: i32 = (F32::abs(fTemp148) < 1.1920929e-07) as i32;
			let mut fTemp150: F32 = if iTemp149 != 0 {0.0} else {F32::exp(-(self.fConst20 / if iTemp149 != 0 {1.0} else {fTemp148}))};
			self.fRec94[0] = (1.0 - fTemp150) * if iTemp2 != 0 {(iTemp2) as F32} else {0.0} + fTemp150 * self.fRec94[1];
			let mut fTemp151: F32 = self.fRec90[0] * self.fRec26[0] * self.fRec94[0];
			self.fRec93[0] = fTemp151 - (self.fRec93[1] * (fTemp147 + fTemp140 * (fTemp146 - self.fConst44) + -64.0) + self.fRec93[2] * (self.fConst46 * fTemp142 + (96.0 - self.fConst38 * (8.0 * fTemp141 + 16.0 * fTemp139))) + self.fRec93[3] * (fTemp147 + fTemp140 * (self.fConst44 - fTemp146) + -64.0) + self.fRec93[4] * (fTemp143 + (16.0 - fTemp144))) / fTemp145;
			let mut fTemp152: F32 = F32::tan(self.fConst47 * fTemp5);
			let mut fTemp153: F32 = F32::sqrt(self.fConst35 * F32::tan(self.fConst48 * fTemp5) * fTemp152);
			let mut fTemp154: F32 = DSP_Snare_faustpower2_f(fTemp153);
			let mut fTemp155: F32 = self.fConst37 * fTemp152 - self.fConst36 * (fTemp154 / fTemp152);
			let mut fTemp156: F32 = DSP_Snare_faustpower2_f(fTemp155);
			let mut fTemp157: F32 = DSP_Snare_faustpower4_f(fTemp153);
			let mut fTemp158: F32 = self.fConst39 * fTemp157 + self.fConst38 * (4.0 * fTemp156 + 8.0 * fTemp154);
			let mut fTemp159: F32 = fTemp155 * (self.fConst42 + self.fConst41 * fTemp154);
			let mut fTemp160: F32 = fTemp159 + fTemp158 + 16.0;
			let mut fTemp161: F32 = self.fConst43 * fTemp154;
			let mut fTemp162: F32 = self.fConst45 * fTemp157;
			self.fRec95[0] = fTemp151 - (self.fRec95[1] * (fTemp162 + fTemp155 * (fTemp161 - self.fConst44) + -64.0) + self.fRec95[2] * (self.fConst46 * fTemp157 + (96.0 - self.fConst38 * (8.0 * fTemp156 + 16.0 * fTemp154))) + self.fRec95[3] * (fTemp162 + fTemp155 * (self.fConst44 - fTemp161) + -64.0) + self.fRec95[4] * (fTemp158 + (16.0 - fTemp159))) / fTemp160;
			let mut fTemp163: F32 = F32::tan(self.fConst6 * F32::min(self.fConst5, fSlow47 * fTemp5));
			let mut fTemp164: F32 = 1.0 / fTemp163;
			let mut fTemp165: F32 = (fTemp164 + 1.4142135) / fTemp163 + 1.0;
			let mut fTemp166: F32 = F32::max(1.0, self.fConst50 / fTemp5);
			self.iRec96[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec96[1], (self.iRec96[1] > 0) as i32), (iTemp1 <= self.iVec3[1]) as i32), iTemp13);
			let mut fTemp167: F32 = (self.iRec96[0]) as F32;
			let mut fTemp168: F32 = F32::tan(self.fConst6 * F32::max(4e+01, fSlow48 * fTemp5));
			let mut fTemp169: F32 = 1.0 / fTemp168;
			let mut fTemp170: F32 = (fTemp169 + 1.4142135) / fTemp168 + 1.0;
			let mut fTemp171: F32 = DSP_Snare_faustpower2_f(fTemp168);
			self.fRec98[0] = self.fRec90[0] - (self.fRec98[2] * ((fTemp169 + -1.4142135) / fTemp168 + 1.0) + 2.0 * self.fRec98[1] * (1.0 - 1.0 / fTemp171)) / fTemp170;
			self.fRec97[0] = (self.fRec98[2] + (self.fRec98[0] - 2.0 * self.fRec98[1])) / (fTemp171 * fTemp170) - (self.fRec97[2] * ((fTemp164 + -1.4142135) / fTemp163 + 1.0) + 2.0 * self.fRec97[1] * (1.0 - 1.0 / DSP_Snare_faustpower2_f(fTemp163))) / fTemp165;
			self.fVec13[0] = fSlow50 * (0.007079458 * (fSlow49 * (self.fRec26[0] * (self.fRec97[2] + self.fRec97[0] + 2.0 * self.fRec97[1]) * F32::max(0.0, F32::min(fTemp167 / fTemp166, (fTemp166 - fTemp167) / F32::max(1.0, self.fConst51 / fTemp5) + 1.0)) / fTemp165) + fSlow46 * (fTemp156 * (4.0 * self.fRec95[0] - 8.0 * self.fRec95[2] + 4.0 * self.fRec95[4]) / fTemp160 + 0.5 * (fTemp141 * (4.0 * self.fRec93[0] - 8.0 * self.fRec93[2] + 4.0 * self.fRec93[4]) / fTemp145))) + 0.01 * (DSP_Snare_faustpower2_f(self.fRec84[0]) * (self.fRec87[2] + self.fRec87[0] + 2.0 * self.fRec87[1]) / fTemp131)) + 0.2 * (self.fRec81[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec80[0]) as i32) as usize] } * F32::powf(fTemp99 / fTemp121, 1.6) + self.fRec77[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec76[0]) as i32) as usize] } * F32::powf(fTemp99 / fTemp116, 1.6) - (self.fRec73[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec72[0]) as i32) as usize] } + self.fRec69[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec68[0]) as i32) as usize] } * F32::powf(fTemp99 / fTemp107, 1.6) + self.fRec65[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec64[0]) as i32) as usize] } * F32::powf(fTemp99 / fTemp101, 1.6))) + fSlow40 * (0.033496544 * self.fRec50[0] + fSlow38 * fTemp76) + fSlow31 * self.fRec23[0] * unsafe { ftbl0DSP_SnareSIG0[((65536.0 * self.fRec21[0]) as i32) as usize] };
			self.fRec99[0] = 0.08 * self.fRec16[1] + 0.92 * self.fRec99[1];
			let mut fTemp172: F32 = fTemp16 * self.fRec99[0] + self.fVec13[1];
			self.fVec14[(self.IOTA0 & 1023) as usize] = fTemp172;
			self.fRec17[0] = fTemp34 * (fTemp23 * (fTemp24 * (0.041666668 * fTemp25 * self.fVec14[((i32::wrapping_sub(self.IOTA0, iTemp33)) & 1023) as usize] - 0.16666667 * fTemp26 * self.fVec14[((i32::wrapping_sub(self.IOTA0, iTemp32)) & 1023) as usize]) + 0.25 * fTemp27 * self.fVec14[((i32::wrapping_sub(self.IOTA0, iTemp31)) & 1023) as usize]) - 0.16666667 * fTemp28 * self.fVec14[((i32::wrapping_sub(self.IOTA0, iTemp30)) & 1023) as usize]) + 0.041666668 * fTemp29 * self.fVec14[((i32::wrapping_sub(self.IOTA0, iTemp21)) & 1023) as usize];
			self.fRec15[0] = self.fRec17[0];
			self.fRec13[0] = self.fConst52 * (self.fRec15[0] - self.fRec15[1] + self.fConst14 * self.fRec13[1]);
			self.fRec12[0] = -(self.fConst55 * (self.fConst54 * self.fRec12[1] - self.fConst53 * (self.fRec13[0] - self.fRec13[1])));
			self.fRec7[0] = 1.5848932 * self.fRec12[0] * (1.0 - self.fRec10[0] + self.fRec10[0] * if (self.fRec8[0] > 0.0) as i32 != 0 {self.fRec11[0] + (1.0 - self.fRec11[0]) * fTemp15} else {fTemp15}) - (self.fRec7[2] * fSlow21 + fTemp12) / fSlow17;
			self.fRec6[0] = (fTemp12 + self.fRec7[0] * fSlow51 + self.fRec7[2] * fSlow19) / fSlow17 - (self.fRec6[2] * ((fTemp8 + -1.847759) / fTemp7 + 1.0) + 2.0 * self.fRec6[1] * fTemp10) / fTemp11;
			self.fRec5[0] = (self.fRec6[2] + self.fRec6[0] + 2.0 * self.fRec6[1]) / fTemp11 - (self.fRec5[2] * ((fTemp8 + -0.76536685) / fTemp7 + 1.0) + 2.0 * fTemp10 * self.fRec5[1]) / fTemp9;
			let mut fTemp173: F32 = (self.fRec5[2] + self.fRec5[0] + 2.0 * self.fRec5[1]) / fTemp9;
			let mut fTemp174: F32 = (fTemp173 + F32::tanh(fTemp173)) * (self.fRec4[0] * (F32::max(0.0, F32::min((self.iRec3[0]) as F32, 1.0) * (1.0 - self.fConst4 * (self.iRec0[0]) as F32)) + -1.0) + 1.0);
			*output0 = fSlow54 * fTemp174;
			*output1 = fSlow55 * fTemp174;
			*output2 = fSlow56 * fTemp174;
			self.iVec0[1] = self.iVec0[0];
			self.IOTA0 = i32::wrapping_add(self.IOTA0, 1);
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec1[1] = self.fRec1[0];
			self.iVec5[1] = self.iVec5[0];
			self.iRec0[1] = self.iRec0[0];
			self.iRec3[1] = self.iRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.iVec6[1] = self.iVec6[0];
			self.fRec8[1] = self.fRec8[0];
			self.iRec9[1] = self.iRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fVec7[1] = self.fVec7[0];
			self.fRec11[1] = self.fRec11[0];
			self.iRec14[1] = self.iRec14[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec41[1] = self.fRec41[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec42[1] = self.fRec42[0];
			self.fRec45[1] = self.fRec45[0];
			self.fRec44[1] = self.fRec44[0];
			self.fRec43[1] = self.fRec43[0];
			self.fRec46[1] = self.fRec46[0];
			self.fRec49[1] = self.fRec49[0];
			self.fRec48[1] = self.fRec48[0];
			self.fRec47[1] = self.fRec47[0];
			self.iRec52[1] = self.iRec52[0];
			self.fVec10[1] = self.fVec10[0];
			self.iRec59[1] = self.iRec59[0];
			self.fRec57[1] = self.fRec57[0];
			self.fRec56[1] = self.fRec56[0];
			self.fRec55[1] = self.fRec55[0];
			self.fVec11[1] = self.fVec11[0];
			self.fRec54[1] = self.fRec54[0];
			self.fRec53[1] = self.fRec53[0];
			self.fRec60[1] = self.fRec60[0];
			self.fRec51[2] = self.fRec51[1];
			self.fRec51[1] = self.fRec51[0];
			self.fVec12[1] = self.fVec12[0];
			self.fRec50[1] = self.fRec50[0];
			self.fRec63[1] = self.fRec63[0];
			self.fRec62[1] = self.fRec62[0];
			self.fRec61[1] = self.fRec61[0];
			self.fRec64[1] = self.fRec64[0];
			self.fRec67[1] = self.fRec67[0];
			self.fRec66[1] = self.fRec66[0];
			self.fRec65[1] = self.fRec65[0];
			self.fRec68[1] = self.fRec68[0];
			self.fRec71[1] = self.fRec71[0];
			self.fRec70[1] = self.fRec70[0];
			self.fRec69[1] = self.fRec69[0];
			self.fRec72[1] = self.fRec72[0];
			self.fRec75[1] = self.fRec75[0];
			self.fRec74[1] = self.fRec74[0];
			self.fRec73[1] = self.fRec73[0];
			self.fRec76[1] = self.fRec76[0];
			self.fRec79[1] = self.fRec79[0];
			self.fRec78[1] = self.fRec78[0];
			self.fRec77[1] = self.fRec77[0];
			self.fRec80[1] = self.fRec80[0];
			self.fRec83[1] = self.fRec83[0];
			self.fRec82[1] = self.fRec82[0];
			self.fRec81[1] = self.fRec81[0];
			self.fRec86[1] = self.fRec86[0];
			self.fRec85[1] = self.fRec85[0];
			self.fRec84[1] = self.fRec84[0];
			self.iRec92[1] = self.iRec92[0];
			self.fRec91[1] = self.fRec91[0];
			self.fRec89[1] = self.fRec89[0];
			self.fRec90[1] = self.fRec90[0];
			self.fRec88[2] = self.fRec88[1];
			self.fRec88[1] = self.fRec88[0];
			self.fRec87[2] = self.fRec87[1];
			self.fRec87[1] = self.fRec87[0];
			self.fRec94[1] = self.fRec94[0];
			for j0 in (1..=4).rev() {
				self.fRec93[j0 as usize] = self.fRec93[(i32::wrapping_sub(j0, 1)) as usize];
			}
			for j1 in (1..=4).rev() {
				self.fRec95[j1 as usize] = self.fRec95[(i32::wrapping_sub(j1, 1)) as usize];
			}
			self.iRec96[1] = self.iRec96[0];
			self.fRec98[2] = self.fRec98[1];
			self.fRec98[1] = self.fRec98[0];
			self.fRec97[2] = self.fRec97[1];
			self.fRec97[1] = self.fRec97[0];
			self.fVec13[1] = self.fVec13[0];
			self.fRec99[1] = self.fRec99[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec7[2] = self.fRec7[1];
			self.fRec7[1] = self.fRec7[0];
			self.fRec6[2] = self.fRec6[1];
			self.fRec6[1] = self.fRec6[0];
			self.fRec5[2] = self.fRec5[1];
			self.fRec5[1] = self.fRec5[0];
		}
	}

}

